DEFINT A-Z
REM $DYNAMIC
REM $INCLUDE: 'C:\QBASIC45\DIRECTQB.BI'

TYPE CHARACTER
	NAMEID AS STRING * 8
	LEVEL AS INTEGER
	CURHP AS INTEGER
	TOTHP AS INTEGER
	CURMP AS INTEGER
	TOTMP AS INTEGER
	STATUS AS INTEGER
	GENERATION AS INTEGER
	EXPER AS INTEGER
	EXPERNEED AS INTEGER
	BODYARMOR AS INTEGER
	HEADARMOR AS INTEGER
	HANDARMOR AS INTEGER
	LEGARMOR AS INTEGER
	WEAPON AS INTEGER
	SPELLPOWER AS INTEGER
	PROTECTION AS INTEGER
	ENCUMBER AS INTEGER
	WEAPONSKILL AS INTEGER
	SHIELDSKILL AS INTEGER
	STR AS INTEGER
	REF AS INTEGER
	AUR AS INTEGER
	WIS AS INTEGER
	WIL AS INTEGER
END TYPE

TYPE PALTYPE
  RED AS INTEGER
  GREEN AS INTEGER
  BLUE AS INTEGER
END TYPE

DECLARE SUB ANIMATECHARACTER (DIRECTION)
DECLARE SUB BRIGHTENOUT (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
DECLARE SUB BRIGHTENIN (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
DECLARE SUB CLOSESCREEN ()
DECLARE SUB DIALOGBOX (BOXTYPE)
DECLARE SUB EMPTYKEYBOARD ()
DECLARE SUB FADEOUT (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
DECLARE SUB FADEIN (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
DECLARE SUB INITBATTLE ()
DECLARE SUB INITMENU ()
DECLARE SUB INTRO ()
DECLARE SUB LOADCHAR ()
DECLARE SUB LOADHOTSPOT ()
DECLARE SUB LOADMAP (MAP$)
DECLARE SUB LOADPAL (COLORS$)
DECLARE SUB LOADHOUSETILES ()
DECLARE SUB LOADTOWNTILES ()
DECLARE SUB SHOWINFO (CHAR)
DECLARE SUB SHOWTILES (DISPLAY)
DECLARE SUB SPLASH ()
DECLARE SUB TILEPLACEL1 (TILE, X, Y)
DECLARE SUB TILEPLACEL2 (TILE, X, Y)
DECLARE SUB PUTLAYER2 (DIRECTION)
DECLARE SUB ULTRAPRINT (TEXT$, X, Y, FCOL, SCOL, XSIZE, YSIZE, STYLE)
DECLARE SUB VPRINT (LAYER, X, Y, TEXT$, FCOL, SCOL, XSIZE, YSIZE, STYLE)
DECLARE SUB WAITRETRACE ()

COMMON SHARED WCOORX, WCOORY, CHARD, CHARFLAG
COMMON SHARED DELAYFACTOR, FRAMESET, GCOORX, GCOORY
COMMON SHARED ANIMATIONFRAME
COMMON SHARED SCRRIGHT, MENU, ENDGAME
COMMON SHARED CRITMOVE, CRITDENSE
COMMON SHARED KRANAR AS CHARACTER, KOLDERON AS CHARACTER, DAARIUN AS CHARACTER

CONST NEUTRAL = -1
CONST KRANARC = 1, KOLDERONC = 2, DAARIUNC = 3
CONST GLOBE = 1, HOUSE = 2

DIM SHARED TILEMAPL1(100, 100)
DIM SHARED TILEMAPL2(100, 100)
DIM SHARED TILEWALK(100, 100)
DIM SHARED CRITMAP(100, 100)
DIM SHARED TREASURE(100)
DIM SHARED TILE1X1N1(140)
DIM SHARED TILE1X1N2(140)
DIM SHARED TILE1X1N3(140)
DIM SHARED TILE1X1N4(140)
DIM SHARED TILE1X1N5(140)
DIM SHARED TILE1X1N6(140)
DIM SHARED TILE1X1N7(140)
DIM SHARED TILE1X1N8(140)
DIM SHARED TILE1X1N9(140)
DIM SHARED TILE1X1N10(140)
DIM SHARED TILE1X1N11(140)
DIM SHARED TILE1X1N12(140)
DIM SHARED TILE1X1N13(140)
DIM SHARED TILE1X1N14(140)
DIM SHARED TILE1X1N15(140)
DIM SHARED TILE1X1N16(140)
DIM SHARED TILE1X1N17(140)
DIM SHARED TILE1X1N18(140)
DIM SHARED TILE1X1N19(140)
DIM SHARED TILE1X1N20(140)
DIM SHARED TILE1X1N21(140)
DIM SHARED TILE1X1N22(140)
DIM SHARED TILE1X1N23(140)
DIM SHARED TILE1X1N24(140)
DIM SHARED TILE1X1N25(140)
DIM SHARED TILE1X1N26(140)
DIM SHARED TILE1X1N27(140)
DIM SHARED TILE1X1N28(140)
DIM SHARED TILE1X1N29(140)
DIM SHARED TILE1X1N30(140)
DIM SHARED TILE1X1N31(140)
DIM SHARED TILE1X1N32(140)
DIM SHARED TILE1X1N33(140)
DIM SHARED TILE1X1N34(140)
DIM SHARED TILE1X1N35(140)
DIM SHARED TILE1X1N36(140)
DIM SHARED TILE1X1N37(140)
DIM SHARED TILE1X1N38(140)
DIM SHARED TILE1X1N39(140)
DIM SHARED TILE1X1N40(140)
DIM SHARED TILE1X1N41(140)
DIM SHARED TILE1X1N42(140)
DIM SHARED TILE1X1N43(140)
DIM SHARED TILE1X1N44(140)
DIM SHARED TILE1X1N45(140)
DIM SHARED TILE1X1N46(140)
DIM SHARED TILE1X1N47(140)
DIM SHARED TILE1X1N48(140)
DIM SHARED TILE1X1N49(140)
DIM SHARED TILE1X1N50(140)
DIM SHARED TILE1X2N1(280)
DIM SHARED TILE1X2N2(280)
DIM SHARED TILE1X2N3(280)
DIM SHARED TILE1X2N4(280)
DIM SHARED TILE1X2N5(280)
DIM SHARED TILE1X2N6(280)
DIM SHARED TILE1X2N7(280)
DIM SHARED TILE1X2N8(280)
DIM SHARED TILE1X2N9(280)
DIM SHARED TILE1X2N10(280)
DIM SHARED TILE1X2N11(280)
DIM SHARED TILE1X2N12(280)
DIM SHARED TILE1X2N13(280)
DIM SHARED TILE1X2N14(280)
DIM SHARED TILE1X2N15(280)
DIM SHARED TILE1X2N16(280)
DIM SHARED TILE1X2N17(280)
DIM SHARED TILE1X2N18(280)
DIM SHARED TILE1X2N19(280)
DIM SHARED TILE1X2N20(280)
DIM SHARED TILE1X3N1(420)
DIM SHARED TILE1X3N2(420)
DIM SHARED TILE1X3N3(420)
DIM SHARED TILE1X3N4(420)
DIM SHARED TILE1X3N5(420)
DIM SHARED TILE1X3N6(420)
DIM SHARED TILE1X3N7(420)
DIM SHARED TILE1X3N8(420)
DIM SHARED TILE1X3N9(420)
DIM SHARED TILE1X3N10(420)
DIM SHARED TILE1X3N11(420)
DIM SHARED TILE1X3N12(420)
DIM SHARED TILE1X3N13(420)
DIM SHARED TILE1X3N14(420)
DIM SHARED TILE1X3N15(420)
DIM SHARED TILE1X3N16(420)
DIM SHARED TILE1X3N17(420)
DIM SHARED TILE1X3N18(420)
DIM SHARED TILE1X3N19(420)
DIM SHARED TILE1X3N20(420)
DIM SHARED TILE1X4N1(560)
DIM SHARED TILE1X4N2(560)
DIM SHARED TILE1X4N3(560)
DIM SHARED TILE1X4N4(560)
DIM SHARED TILE1X4N5(560)
DIM SHARED TILE1X4N6(560)
DIM SHARED TILE1X4N7(560)
DIM SHARED TILE1X4N8(560)
DIM SHARED TILE1X4N9(560)
DIM SHARED TILE1X4N10(560)
DIM SHARED TILE1X4N11(560)
DIM SHARED TILE1X4N12(560)
DIM SHARED TILE1X4N13(560)
DIM SHARED TILE1X4N14(560)
DIM SHARED TILE1X4N15(560)
DIM SHARED TILE1X4N16(560)
DIM SHARED TILE1X4N17(560)
DIM SHARED TILE1X4N18(560)
DIM SHARED TILE1X4N19(560)
DIM SHARED TILE1X4N20(560)
DIM SHARED TILE2X1N1(280)
DIM SHARED TILE2X1N2(280)
DIM SHARED TILE2X1N3(280)
DIM SHARED TILE2X1N4(280)
DIM SHARED TILE2X1N5(280)
DIM SHARED TILE2X1N6(280)
DIM SHARED TILE2X1N7(280)
DIM SHARED TILE2X1N8(280)
DIM SHARED TILE2X1N9(280)
DIM SHARED TILE2X1N10(280)
DIM SHARED TILE2X1N11(280)
DIM SHARED TILE2X1N12(280)
DIM SHARED TILE2X1N13(280)
DIM SHARED TILE2X1N14(280)
DIM SHARED TILE2X1N15(280)
DIM SHARED TILE2X1N16(280)
DIM SHARED TILE2X1N17(280)
DIM SHARED TILE2X1N18(280)
DIM SHARED TILE2X1N19(280)
DIM SHARED TILE2X1N20(280)
DIM SHARED TILE2X2N1(560)
DIM SHARED TILE2X2N2(560)
DIM SHARED TILE2X2N3(560)
DIM SHARED TILE2X2N4(560)
DIM SHARED TILE2X2N5(560)
DIM SHARED TILE2X2N6(560)
DIM SHARED TILE2X2N7(560)
DIM SHARED TILE2X2N8(560)
DIM SHARED TILE2X2N9(560)
DIM SHARED TILE2X2N10(560)
DIM SHARED TILE2X2N11(560)
DIM SHARED TILE2X2N12(560)
DIM SHARED TILE2X2N13(560)
DIM SHARED TILE2X2N14(560)
DIM SHARED TILE2X2N15(560)
DIM SHARED TILE2X2N16(560)
DIM SHARED TILE2X2N17(560)
DIM SHARED TILE2X2N18(560)
DIM SHARED TILE2X2N19(560)
DIM SHARED TILE2X2N20(560)
DIM SHARED TILE1X1N1L2(140)
DIM SHARED TILE1X1N2L2(140)
DIM SHARED TILE1X1N3L2(140)
DIM SHARED TILE1X1N4L2(140)
DIM SHARED TILE1X1N5L2(140)
DIM SHARED TILE1X1N6L2(140)
DIM SHARED TILE1X1N7L2(140)
DIM SHARED TILE1X1N8L2(140)
DIM SHARED TILE1X1N9L2(140)
DIM SHARED TILE1X1N10L2(140)
DIM SHARED TILE1X1N11L2(140)
DIM SHARED TILE1X1N12L2(140)
DIM SHARED TILE1X1N13L2(140)
DIM SHARED TILE1X1N14L2(140)
DIM SHARED TILE1X1N15L2(140)
DIM SHARED TILE1X1N16L2(140)
DIM SHARED TILE1X1N17L2(140)
DIM SHARED TILE1X1N18L2(140)
DIM SHARED TILE1X1N19L2(140)
DIM SHARED TILE1X1N20L2(140)
DIM SHARED TILE1X1N21L2(140)
DIM SHARED TILE1X1N22L2(140)
DIM SHARED TILE1X1N23L2(140)
DIM SHARED TILE1X1N24L2(140)
DIM SHARED TILE1X1N25L2(140)
DIM SHARED TILE1X1N26L2(140)
DIM SHARED TILE1X1N27L2(140)
DIM SHARED TILE1X1N28L2(140)
DIM SHARED TILE1X1N29L2(140)
DIM SHARED TILE1X1N30L2(140)
DIM SHARED TILE1X1N31L2(140)
DIM SHARED TILE1X1N32L2(140)
DIM SHARED TILE1X1N33L2(140)
DIM SHARED TILE1X1N34L2(140)
DIM SHARED TILE1X1N35L2(140)
DIM SHARED TILE1X1N36L2(140)
DIM SHARED TILE1X1N37L2(140)
DIM SHARED TILE1X1N38L2(140)
DIM SHARED TILE1X1N39L2(140)
DIM SHARED TILE1X1N40L2(140)
DIM SHARED TILE1X1N41L2(140)
DIM SHARED TILE1X1N42L2(140)
DIM SHARED TILE1X1N43L2(140)
DIM SHARED TILE1X1N44L2(140)
DIM SHARED TILE1X1N45L2(140)
DIM SHARED TILE1X1N46L2(140)
DIM SHARED TILE1X1N47L2(140)
DIM SHARED TILE1X1N48L2(140)
DIM SHARED TILE1X1N49L2(140)
DIM SHARED TILE1X1N50L2(140)
DIM SHARED TILE1X2N1L2(280)
DIM SHARED TILE1X2N2L2(280)
DIM SHARED TILE1X2N3L2(280)
DIM SHARED TILE1X2N4L2(280)
DIM SHARED TILE1X2N5L2(280)
DIM SHARED TILE1X2N6L2(280)
DIM SHARED TILE1X2N7L2(280)
DIM SHARED TILE1X2N8L2(280)
DIM SHARED TILE1X2N9L2(280)
DIM SHARED TILE1X2N10L2(280)
DIM SHARED TILE1X2N11L2(280)
DIM SHARED TILE1X2N12L2(280)
DIM SHARED TILE1X2N13L2(280)
DIM SHARED TILE1X2N14L2(280)
DIM SHARED TILE1X2N15L2(280)
DIM SHARED TILE1X2N16L2(280)
DIM SHARED TILE1X2N17L2(280)
DIM SHARED TILE1X2N18L2(280)
DIM SHARED TILE1X2N19L2(280)
DIM SHARED TILE1X2N20L2(280)
DIM SHARED TILE1X3N1L2(420)
DIM SHARED TILE1X3N2L2(420)
DIM SHARED TILE1X3N3L2(420)
DIM SHARED TILE1X3N4L2(420)
DIM SHARED TILE1X3N5L2(420)
DIM SHARED TILE1X3N6L2(420)
DIM SHARED TILE1X3N7L2(420)
DIM SHARED TILE1X3N8L2(420)
DIM SHARED TILE1X3N9L2(420)
DIM SHARED TILE1X3N10L2(420)
DIM SHARED TILE1X3N11L2(420)
DIM SHARED TILE1X3N12L2(420)
DIM SHARED TILE1X3N13L2(420)
DIM SHARED TILE1X3N14L2(420)
DIM SHARED TILE1X3N15L2(420)
DIM SHARED TILE1X3N16L2(420)
DIM SHARED TILE1X3N17L2(420)
DIM SHARED TILE1X3N18L2(420)
DIM SHARED TILE1X3N19L2(420)
DIM SHARED TILE1X3N20L2(420)
DIM SHARED TILE1X4N1L2(560)
DIM SHARED TILE1X4N2L2(560)
DIM SHARED TILE1X4N3L2(560)
DIM SHARED TILE1X4N4L2(560)
DIM SHARED TILE1X4N5L2(560)
DIM SHARED TILE1X4N6L2(560)
DIM SHARED TILE1X4N7L2(560)
DIM SHARED TILE1X4N8L2(560)
DIM SHARED TILE1X4N9L2(560)
DIM SHARED TILE1X4N10L2(560)
DIM SHARED TILE1X4N11L2(560)
DIM SHARED TILE1X4N12L2(560)
DIM SHARED TILE1X4N13L2(560)
DIM SHARED TILE1X4N14L2(560)
DIM SHARED TILE1X4N15L2(560)
DIM SHARED TILE1X4N16L2(560)
DIM SHARED TILE1X4N17L2(560)
DIM SHARED TILE1X4N18L2(560)
DIM SHARED TILE1X4N19L2(560)
DIM SHARED TILE1X4N20L2(560)
DIM SHARED TILE2X1N1L2(280)
DIM SHARED TILE2X1N2L2(280)
DIM SHARED TILE2X1N3L2(280)
DIM SHARED TILE2X1N4L2(280)
DIM SHARED TILE2X1N5L2(280)
DIM SHARED TILE2X1N6L2(280)
DIM SHARED TILE2X1N7L2(280)
DIM SHARED TILE2X1N8L2(280)
DIM SHARED TILE2X1N9L2(280)
DIM SHARED TILE2X1N10L2(280)
DIM SHARED TILE2X1N11L2(280)
DIM SHARED TILE2X1N12L2(280)
DIM SHARED TILE2X1N13L2(280)
DIM SHARED TILE2X1N14L2(280)
DIM SHARED TILE2X1N15L2(280)
DIM SHARED TILE2X1N16L2(280)
DIM SHARED TILE2X1N17L2(280)
DIM SHARED TILE2X1N18L2(280)
DIM SHARED TILE2X1N19L2(280)
DIM SHARED TILE2X1N20L2(280)
DIM SHARED TILE2X2N1L2(560)
DIM SHARED TILE2X2N2L2(560)
DIM SHARED TILE2X2N3L2(560)
DIM SHARED TILE2X2N4L2(560)
DIM SHARED TILE2X2N5L2(560)
DIM SHARED TILE2X2N6L2(560)
DIM SHARED TILE2X2N7L2(560)
DIM SHARED TILE2X2N8L2(560)
DIM SHARED TILE2X2N9L2(560)
DIM SHARED TILE2X2N10L2(560)
DIM SHARED TILE2X2N11L2(560)
DIM SHARED TILE2X2N12L2(560)
DIM SHARED TILE2X2N13L2(560)
DIM SHARED TILE2X2N14L2(560)
DIM SHARED TILE2X2N15L2(560)
DIM SHARED TILE2X2N16L2(560)
DIM SHARED TILE2X2N17L2(560)
DIM SHARED TILE2X2N18L2(560)
DIM SHARED TILE2X2N19L2(560)
DIM SHARED TILE2X2N20L2(560)
DIM SHARED LINKD1(140)
DIM SHARED LINKD2(140)
DIM SHARED LINKU1(140)
DIM SHARED LINKU2(140)
DIM SHARED LINKR1(140)
DIM SHARED LINKR2(140)
DIM SHARED LINKL1(140)
DIM SHARED LINKL2(140)
DIM SHARED KRANG1A(400)
DIM SHARED KRANG1B(400)
DIM SHARED KRANG1C(400)
DIM SHARED DAARG1A(400)
DIM SHARED DAARG1B(400)
DIM SHARED DAARG1C(400)
DIM SHARED KOLDG1A(400)
DIM SHARED KOLDG1B(400)
DIM SHARED KOLDG1C(400)
DIM SHARED POINTER(140)
DIM SHARED RGBPAL(0 TO 255) AS PALTYPE
DIM SHARED PALMEM(0 TO 255) AS PALTYPE
DIM SHARED BYTE AS STRING * 1

WCOORX = 322: WCOORY = 612
GCOORX = 160: GCOORY = 118
CHARFLAG = GLOBE: CRITDENSE = 12: RANDSAFE = INT(RND * 3) + INT(CRITDENSE / 2)
KRANAR.NAMEID = "Kranar": KRANAR.GENERATION = 1
KOLDERON.NAMEID = "Kolderon": KOLDERON.GENERATION = 1
DAARIUN.NAMEID = "Daariun": DAARIUN.GENERATION = 1

CLS : SCREEN 0: WIDTH 80
LOCATE 1, 1: PRINT "THE ULTRAVERSE ENGINE v0.01 beta (c)1996/2000, Generation-X"
LOCATE 2, 1: PRINT "Compiled using QuickBasic 4.50, and Turbo Assembler 4"
LOCATE 3, 1: PRINT "Enter any key to begin"
DO: LOOP WHILE INKEY$ = ""

RESULT = DQBinit(1, 0)
IF RESULT <> 0 THEN
  SCREEN 0
  WIDTH 80
  PRINT "Unable to initiate EMS routines. Reason given:"
  IF RESULT = 1 THEN PRINT "386 or Lower Processor Detected"
  IF RESULT = 2 THEN PRINT "EMS Memory Manager Not Located."
  IF RESULT = 3 THEN PRINT "Unable To Allocate EMS Layers."
  PRINT "Exiting program."
  SLEEP
  DQBCLOSE
  SCREEN 0
  END
END IF

DQBINITVGA
DQBINSTALLKEYBOARD

SPLASH

LOADTOWNTILES
LOADMAP "MAPS\TEST1.MAP"
CHARD = UP

INTRO

FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
ANIMATECHARACTER CHARD
SHOWTILES TRUE
FADEIN 0, 0, 255, RGBPAL(), PALMEM()

DO
  IF DQBkey(KEYDOWN) THEN
	CHARD = DOWN
	ANIMATECHARACTER DOWN
	MENU = FALSE
  END IF
  IF DQBkey(KEYUP) THEN
	CHARD = UP
	ANIMATECHARACTER UP
	MENU = FALSE
  END IF
  IF DQBkey(KEYLEFT) THEN
	CHARD = LEFT
	ANIMATECHARACTER LEFT
	MENU = FALSE
  END IF
  IF DQBkey(KEYRIGHT) THEN
	CHARD = RIGHT
	ANIMATECHARACTER RIGHT
	MENU = FALSE
  END IF
  IF DQBkey(&H3B) THEN
	INITMENU
  END IF
  IF ENDGAME = TRUE THEN
	FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
	EXIT DO
  END IF
  SHOWTILES TRUE
  CRITDENSE = (CRITMAP(WCOORX / 16, WCOORY / 16))
LOOP
DQBINITTEXT
DQBREMOVEKEYBOARD
DQBCLOSE
PRINT "WCOORX = "; WCOORX
PRINT "WCOORY = "; WCOORY
PRINT "GCOORX = "; GCOORX
PRINT "GCOORY = "; GCOORY
END

SUB ANIMATECHARACTER (DIRECTION)
  FRAMESET = FALSE
  SELECT CASE DIRECTION
	CASE DOWN
	  IF TILEWALK(INT((WCOORX + 10) / 16), INT((WCOORY + 16) / 16)) > 0 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 16) / 16)) > 0 THEN
		IF TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 16) / 16)) = 2 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 16) / 16)) = 2 THEN LOADHOTSPOT
		FOR WCOORY = WCOORY TO WCOORY + 1
		  SHOWTILES FALSE
		  IF GCOORY < 130 THEN
			GCOORY = GCOORY + 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKD1(0)), VARPTR(LINKD1(0))
			PUTLAYER2 DOWN
		  END IF
		  IF GCOORY > 129 THEN
			DQBPUT 1, GCOORX, 130, VARSEG(LINKD1(0)), VARPTR(LINKD1(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		EMPTYKEYBOARD
		FOR TIME1 = 0 TO DELAYFACTOR
		  FOR TIME2 = 0 TO DELAYFACTOR
		  NEXT
		NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
	  END IF
	  IF TILEWALK(INT((WCOORX + 10) / 16), INT((WCOORY + 16) / 16)) > 0 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 16) / 16)) > 0 THEN
		IF TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 16) / 16)) = 2 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 16) / 16)) = 2 THEN LOADHOTSPOT
		FOR WCOORY = WCOORY TO WCOORY + 1
		  SHOWTILES FALSE
		  IF GCOORY < 130 THEN
			GCOORY = GCOORY + 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKD2(0)), VARPTR(LINKD2(0))
			PUTLAYER2 DOWN
		  END IF
		  IF GCOORY > 129 THEN
			DQBPUT 1, GCOORX, 130, VARSEG(LINKD2(0)), VARPTR(LINKD2(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		EMPTYKEYBOARD
		FOR TIME1 = 0 TO DELAYFACTOR
		  FOR TIME2 = 0 TO DELAYFACTOR
		  NEXT
		NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
	  END IF
	CASE UP
	  IF TILEWALK(INT((WCOORX + 11) / 16), INT((WCOORY + 14) / 16)) > 0 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 14) / 16)) > 0 THEN
		IF TILEWALK(INT((WCOORX + 11) / 16), INT((WCOORY + 14) / 16)) = 2 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 14) / 16)) = 2 THEN LOADHOTSPOT
		FOR WCOORY = WCOORY TO WCOORY - 1 STEP -1
		  SHOWTILES FALSE
		  IF GCOORY > 49 THEN
			GCOORY = GCOORY - 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKU1(0)), VARPTR(LINKU1(0))
			PUTLAYER2 UP
		  END IF
		  IF GCOORY < 50 THEN
			DQBPUT 1, GCOORX, 49, VARSEG(LINKU1(0)), VARPTR(LINKU1(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		EMPTYKEYBOARD
		FOR TIME1 = 0 TO DELAYFACTOR
		  FOR TIME2 = 0 TO DELAYFACTOR
		  NEXT
		NEXT
	  IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
	  END IF
	  IF TILEWALK(INT((WCOORX + 11) / 16), INT((WCOORY + 14) / 16)) > 0 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 14) / 16)) > 0 THEN
		IF TILEWALK(INT((WCOORX + 11) / 16), INT((WCOORY + 14) / 16)) = 2 AND TILEWALK(INT((WCOORX + 2) / 16), INT((WCOORY + 14) / 16)) = 2 THEN LOADHOTSPOT
		  FOR WCOORY = WCOORY TO WCOORY - 1 STEP -1
			SHOWTILES FALSE
			IF GCOORY > 49 THEN
			  GCOORY = GCOORY - 1
			  DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKU2(0)), VARPTR(LINKU2(0))
			  PUTLAYER2 UP
			END IF
			IF GCOORY < 50 THEN
			  DQBPUT 1, GCOORX, 49, VARSEG(LINKU2(0)), VARPTR(LINKU2(0))
			  PUTLAYER2 NEUTRAL
			END IF
			DQBCOPYLAYER 1, VIDEO
			DQBCLEARLAYER 1
			CRITMOVE = CRITMOVE + 1
		  NEXT
		  FOR TIME1 = 0 TO DELAYFACTOR
			FOR TIME2 = 0 TO DELAYFACTOR
			NEXT
		  NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
		END IF
	CASE LEFT
	  IF TILEWALK(INT((WCOORX - 1) / 16), INT((WCOORY + 16) / 16)) > 0 AND TILEWALK(INT((WCOORX - 1) / 16), INT((WCOORY + 16) / 16)) > 0 OR TILEWALK(INT((WCOORX - 1) / 16), INT((WCOORY + 14) / 16)) > 0 AND TILEWALK(INT((WCOORX - 1) / 16), INT(( _
WCOORY + 14) / 16)) > 0 THEN
		FOR WCOORX = WCOORX TO WCOORX - 2 STEP -1
		  SHOWTILES FALSE
		  IF GCOORX > 70 THEN
			GCOORX = GCOORX - 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKL1(0)), VARPTR(LINKL1(0))
			PUTLAYER2 LEFT
		  END IF
		  IF GCOORX < 71 THEN
			DQBPUT 1, 70, GCOORY, VARSEG(LINKL1(0)), VARPTR(LINKL1(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
	  END IF
	  EMPTYKEYBOARD
	  FOR TIME1 = 0 TO DELAYFACTOR
		FOR TIME2 = 0 TO DELAYFACTOR
		NEXT
	  NEXT
	  IF TILEWALK(INT((WCOORX - 1) / 16), INT((WCOORY + 16) / 16)) > 0 AND TILEWALK(INT((WCOORX - 1) / 16), INT((WCOORY + 16) / 16)) > 0 OR TILEWALK(INT((WCOORX - 1) / 16), INT((WCOORY + 14) / 16)) > 0 AND TILEWALK(INT((WCOORX - 1) / 16), INT(( _
WCOORY + 14) / 16)) > 0 THEN
		FOR WCOORX = WCOORX TO WCOORX - 2 STEP -1
		  SHOWTILES FALSE
		  IF GCOORX > 70 THEN
			GCOORX = GCOORX - 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKL2(0)), VARPTR(LINKL2(0))
			PUTLAYER2 LEFT
		  END IF
		  IF GCOORX < 71 THEN
			DQBPUT 1, 70, GCOORY, VARSEG(LINKL2(0)), VARPTR(LINKL2(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
	  END IF
	CASE RIGHT
	  IF TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 16) / 16)) > 0 AND TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 16) / 16)) > 0 OR TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 14) / 16)) > 0 AND TILEWALK(INT((WCOORX + 13) / 16),  _
INT((WCOORY + 14) / 16)) > 0 THEN
		FOR WCOORX = WCOORX TO WCOORX + 2
		  SHOWTILES FALSE
		  IF GCOORX < 232 THEN
			GCOORX = GCOORX + 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKR1(0)), VARPTR(LINKR1(0))
			PUTLAYER2 RIGHT
		  END IF
		  IF GCOORX > 231 THEN
			DQBPUT 1, 232, GCOORY, VARSEG(LINKR1(0)), VARPTR(LINKR1(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE THEN INITBATTLE
	  END IF
	  EMPTYKEYBOARD
	  FOR TIME1 = 0 TO DELAYFACTOR
		FOR TIME2 = 0 TO DELAYFACTOR
		NEXT
	  NEXT
	  IF TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 16) / 16)) > 0 AND TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 16) / 16)) > 0 OR TILEWALK(INT((WCOORX + 13) / 16), INT((WCOORY + 14) / 16)) > 0 AND TILEWALK(INT((WCOORX + 13) / 16),  _
INT((WCOORY + 14) / 16)) > 0 THEN
		FOR WCOORX = WCOORX TO WCOORX + 2
		  SHOWTILES FALSE
		  IF GCOORX < 232 THEN
			GCOORX = GCOORX + 1
			DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKR2(0)), VARPTR(LINKR2(0))
			PUTLAYER2 RIGHT
		  END IF
		  IF GCOORX > 231 THEN
			DQBPUT 1, 232, GCOORY, VARSEG(LINKR2(0)), VARPTR(LINKR2(0))
			PUTLAYER2 NEUTRAL
		  END IF
		  DQBCOPYLAYER 1, VIDEO
		  DQBCLEARLAYER 1
		  CRITMOVE = CRITMOVE + 1
		NEXT
		IF INT(CRITMOVE / 16) >= 3 + CRITDENSE + RANDSAFE THEN INITBATTLE
	  END IF
  END SELECT
END SUB

SUB BRIGHTENIN (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
    OUT &H3C7, RANGESTART
    FOR SAVEPRESENTPAL = RANGESTART TO RANGEEND
       RGBPAL(SAVEPRESENTPAL).RED = INP(&H3C9)
       RGBPAL(SAVEPRESENTPAL).GREEN = INP(&H3C9)
       RGBPAL(SAVEPRESENTPAL).BLUE = INP(&H3C9)
    NEXT SAVEPRESENTPAL
    FOR BRIGHTENINPAL = 0 TO 63
	FOR BRIGHTENSCAN = RANGESTART TO RANGEEND
	    SELECT CASE KEEPCOLOR
	      CASE 0
		  IF PALMEM(BRIGHTENSCAN).RED < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).RED > PALMEM(BRIGHTENSCAN).RED THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED - 1
		  IF PALMEM(BRIGHTENSCAN).GREEN < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).GREEN > PALMEM(BRIGHTENSCAN).GREEN THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN - 1
		  IF PALMEM(BRIGHTENSCAN).BLUE < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).BLUE > PALMEM(BRIGHTENSCAN).BLUE THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE - 1
	      CASE 1
		  IF PALMEM(BRIGHTENSCAN).GREEN < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).GREEN > PALMEM(BRIGHTENSCAN).GREEN THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN - 1
		  IF PALMEM(BRIGHTENSCAN).BLUE < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).BLUE > PALMEM(BRIGHTENSCAN).BLUE THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE - 1
	      CASE 2
		  IF PALMEM(BRIGHTENSCAN).RED < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).RED > PALMEM(BRIGHTENSCAN).RED THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED - 1
		  IF PALMEM(BRIGHTENSCAN).BLUE < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).BLUE > PALMEM(BRIGHTENSCAN).BLUE THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE - 1
	      CASE 3
		  IF PALMEM(BRIGHTENSCAN).RED < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).RED > PALMEM(BRIGHTENSCAN).RED THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED - 1
		  IF PALMEM(BRIGHTENSCAN).GREEN < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).GREEN > PALMEM(BRIGHTENSCAN).GREEN THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN - 1
	      CASE 4
		  IF PALMEM(BRIGHTENSCAN).BLUE < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).BLUE > PALMEM(BRIGHTENSCAN).BLUE THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE - 1
	      CASE 5
		  IF PALMEM(BRIGHTENSCAN).GREEN < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).GREEN > PALMEM(BRIGHTENSCAN).GREEN THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN - 1
	      CASE 6
		  IF PALMEM(BRIGHTENSCAN).RED < BRIGHTENINPAL AND RGBPAL(BRIGHTENSCAN).RED > PALMEM(BRIGHTENSCAN).RED THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED - 1
	      END SELECT
	NEXT BRIGHTENSCAN
	OUT &H3C8, RANGESTART
	WAITRETRACE
	FOR BRIGHTENPAL = RANGESTART TO RANGEEND
	    OUT &H3C9, RGBPAL(BRIGHTENPAL).RED
	    OUT &H3C9, RGBPAL(BRIGHTENPAL).GREEN
	    OUT &H3C9, RGBPAL(BRIGHTENPAL).BLUE
	NEXT BRIGHTENPAL
    NEXT BRIGHTENINPAL
END SUB

SUB BRIGHTENOUT (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
    OUT &H3C7, RANGESTART
    FOR SAVEOLDPAL = RANGESTART TO RANGEEND
	PALMEM(SAVEOLDPAL).RED = INP(&H3C9)
	PALMEM(SAVEOLDPAL).GREEN = INP(&H3C9)
	PALMEM(SAVEOLDPAL).BLUE = INP(&H3C9)
    NEXT SAVEOLDPAL
    OUT &H3C7, RANGESTART
    FOR SAVEPRESENTPAL = RANGESTART TO RANGEEND
	RGBPAL(SAVEPRESENTPAL).RED = INP(&H3C9)
	RGBPAL(SAVEPRESENTPAL).GREEN = INP(&H3C9)
	RGBPAL(SAVEPRESENTPAL).BLUE = INP(&H3C9)
    NEXT SAVEPRESENTPAL
    FOR BRIGHTENOUTPAL = 0 TO 63
	FOR BRIGHTENSCAN = RANGESTART TO RANGEEND
	    SELECT CASE KEEPCOLOR
	    CASE 0
	       IF RGBPAL(BRIGHTENSCAN).RED < 63 THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED + 1
	       IF RGBPAL(BRIGHTENSCAN).GREEN < 63 THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN + 1
	       IF RGBPAL(BRIGHTENSCAN).BLUE < 63 THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE + 1
	    CASE 1
	       IF RGBPAL(BRIGHTENSCAN).GREEN < 63 THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN + 1
	       IF RGBPAL(BRIGHTENSCAN).BLUE < 63 THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE + 1
	    CASE 2
	       IF RGBPAL(BRIGHTENSCAN).RED < 63 THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED + 1
	       IF RGBPAL(BRIGHTENSCAN).BLUE < 63 THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE + 1
	    CASE 3
	       IF RGBPAL(BRIGHTENSCAN).RED < 63 THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED + 1
	       IF RGBPAL(BRIGHTENSCAN).GREEN < 63 THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN + 1
	    CASE 4
	       IF RGBPAL(BRIGHTENSCAN).BLUE < 63 THEN RGBPAL(BRIGHTENSCAN).BLUE = RGBPAL(BRIGHTENSCAN).BLUE + 1
	    CASE 5
	       IF RGBPAL(BRIGHTENSCAN).GREEN < 63 THEN RGBPAL(BRIGHTENSCAN).GREEN = RGBPAL(BRIGHTENSCAN).GREEN + 1
	    CASE 6
	       IF RGBPAL(BRIGHTENSCAN).RED < 63 THEN RGBPAL(BRIGHTENSCAN).RED = RGBPAL(BRIGHTENSCAN).RED + 1
	    END SELECT
	NEXT BRIGHTENSCAN
	OUT &H3C8, RANGESTART
	WAITRETRACE
	FOR BRIGHTENPAL = RANGESTART TO RANGEEND
	    OUT &H3C9, RGBPAL(BRIGHTENPAL).RED
	    OUT &H3C9, RGBPAL(BRIGHTENPAL).GREEN
	    OUT &H3C9, RGBPAL(BRIGHTENPAL).BLUE
	NEXT BRIGHTENPAL
    NEXT BRIGHTENOUTPAL
END SUB

SUB DIALOGBOX (BOXTYPE)

IF BOXTYPE = 1 THEN
	DQBbox VIDEO, 20, 120, 300, 183, 144
	DQBbox VIDEO, 21, 121, 299, 182, 57
	DQBbox VIDEO, 22, 122, 298, 181, 3
	DQBboxf VIDEO, 23, 123, 297, 180, 43
END IF

END SUB

SUB EMPTYKEYBOARD
  DEF SEG = 0: POKE &H41A, PEEK(&H41C): DEF SEG
END SUB

SUB FADEIN (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
    OUT &H3C7, RANGESTART
    FOR SAVEPRESENTPAL = RANGESTART TO RANGEEND
	RGBPAL(SAVEPRESENTPAL).RED = INP(&H3C9)
	RGBPAL(SAVEPRESENTPAL).GREEN = INP(&H3C9)
	RGBPAL(SAVEPRESENTPAL).BLUE = INP(&H3C9)
    NEXT SAVEPRESENTPAL
    FOR FADEINPAL = 0 TO 63
	FOR FADESCAN = RANGESTART TO RANGEEND
	    SELECT CASE KEEPCOLOR
	       CASE 0
		   IF 63 - PALMEM(FADESCAN).RED < FADEINPAL AND RGBPAL(FADESCAN).RED < PALMEM(FADESCAN).RED THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED + 1
		   IF 63 - PALMEM(FADESCAN).GREEN < FADEINPAL AND RGBPAL(FADESCAN).GREEN < PALMEM(FADESCAN).GREEN THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN + 1
		   IF 63 - PALMEM(FADESCAN).BLUE < FADEINPAL AND RGBPAL(FADESCAN).BLUE < PALMEM(FADESCAN).BLUE THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE + 1
	       CASE 1
		   IF 63 - PALMEM(FADESCAN).GREEN < FADEINPAL AND RGBPAL(FADESCAN).GREEN < PALMEM(FADESCAN).GREEN THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN + 1
		   IF 63 - PALMEM(FADESCAN).BLUE < FADEINPAL AND RGBPAL(FADESCAN).BLUE < PALMEM(FADESCAN).BLUE THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE + 1
	       CASE 2
		   IF 63 - PALMEM(FADESCAN).RED < FADEINPAL AND RGBPAL(FADESCAN).RED < PALMEM(FADESCAN).RED THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED + 1
		   IF 63 - PALMEM(FADESCAN).BLUE < FADEINPAL AND RGBPAL(FADESCAN).BLUE < PALMEM(FADESCAN).BLUE THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE + 1
	       CASE 3
		   IF 63 - PALMEM(FADESCAN).RED < FADEINPAL AND RGBPAL(FADESCAN).RED < PALMEM(FADESCAN).RED THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED + 1
		   IF 63 - PALMEM(FADESCAN).GREEN < FADEINPAL AND RGBPAL(FADESCAN).GREEN < PALMEM(FADESCAN).GREEN THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN + 1
	       CASE 4
		   IF 63 - PALMEM(FADESCAN).BLUE < FADEINPAL AND RGBPAL(FADESCAN).BLUE < PALMEM(FADESCAN).BLUE THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE + 1
	       CASE 5
		   IF 63 - PALMEM(FADESCAN).GREEN < FADEINPAL AND RGBPAL(FADESCAN).GREEN < PALMEM(FADESCAN).GREEN THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN + 1
	       CASE 6
		   IF 63 - PALMEM(FADESCAN).RED < FADEINPAL AND RGBPAL(FADESCAN).RED < PALMEM(FADESCAN).RED THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED + 1
	    END SELECT
	NEXT FADESCAN
	OUT &H3C8, RANGESTART
	WAITRETRACE
	FOR FADEPAL = RANGESTART TO RANGEEND
	    OUT &H3C9, RGBPAL(FADEPAL).RED
	    OUT &H3C9, RGBPAL(FADEPAL).GREEN
	    OUT &H3C9, RGBPAL(FADEPAL).BLUE
	NEXT FADEPAL
    NEXT FADEINPAL
END SUB

SUB FADEOUT (KEEPCOLOR, RANGESTART, RANGEEND, RGBPAL() AS PALTYPE, PALMEM() AS PALTYPE)
    OUT &H3C7, RANGESTART
    FOR SAVEOLDPAL = RANGESTART TO RANGEEND
	PALMEM(SAVEOLDPAL).RED = INP(&H3C9)
	PALMEM(SAVEOLDPAL).GREEN = INP(&H3C9)
	PALMEM(SAVEOLDPAL).BLUE = INP(&H3C9)
    NEXT SAVEOLDPAL
    OUT &H3C7, RANGESTART
    FOR SAVEPRESENTPAL = RANGESTART TO RANGEEND
	RGBPAL(SAVEPRESENTPAL).RED = INP(&H3C9)
	RGBPAL(SAVEPRESENTPAL).GREEN = INP(&H3C9)
	RGBPAL(SAVEPRESENTPAL).BLUE = INP(&H3C9)
    NEXT SAVEPRESENTPAL
    FOR FADEOUTPAL = 0 TO 63
	FOR FADESCAN = RANGESTART TO RANGEEND
	    SELECT CASE KEEPCOLOR
	       CASE 0
		   IF RGBPAL(FADESCAN).RED > 0 THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED - 1
		   IF RGBPAL(FADESCAN).GREEN > 0 THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN - 1
		   IF RGBPAL(FADESCAN).BLUE > 0 THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE - 1
	       CASE 1
		   IF RGBPAL(FADESCAN).GREEN > 0 THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN - 1
		   IF RGBPAL(FADESCAN).BLUE > 0 THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE - 1
	       CASE 2
		   IF RGBPAL(FADESCAN).RED > 0 THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED - 1
		   IF RGBPAL(FADESCAN).BLUE > 0 THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE - 1
	       CASE 3
		   IF RGBPAL(FADESCAN).RED > 0 THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED - 1
		   IF RGBPAL(FADESCAN).GREEN > 0 THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN - 1
	       CASE 4
		   IF RGBPAL(FADESCAN).BLUE > 0 THEN RGBPAL(FADESCAN).BLUE = RGBPAL(FADESCAN).BLUE - 1
	       CASE 5
		   IF RGBPAL(FADESCAN).GREEN > 0 THEN RGBPAL(FADESCAN).GREEN = RGBPAL(FADESCAN).GREEN - 1
	       CASE 6
		   IF RGBPAL(FADESCAN).RED > 0 THEN RGBPAL(FADESCAN).RED = RGBPAL(FADESCAN).RED - 1
	    END SELECT
	NEXT FADESCAN
	OUT &H3C8, RANGESTART
	WAITRETRACE
	FOR FADEPAL = RANGESTART TO RANGEEND
	    OUT &H3C9, RGBPAL(FADEPAL).RED
	    OUT &H3C9, RGBPAL(FADEPAL).GREEN
	    OUT &H3C9, RGBPAL(FADEPAL).BLUE
	NEXT FADEPAL
    NEXT FADEOUTPAL
END SUB

SUB INITBATTLE
	IF CRITDENSE > 0 THEN
		BEEP
		CRITMOVE = 0: RANDSAFE = INT(RND * 3) + INT(CRITDENSE / 2)
	ELSE
		CRITMOVE = 0
	END IF
END SUB

SUB INITMENU
	MENU = TRUE
	CURSOR = 1
	OPT = 0
	FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
	DQBCLEARLAYER VIDEO
DRAWSCREEN:
	LOADPAL "KRANAR.PAL"
	DQBbox 1, 15, 10, 305, 183, 144
	DQBbox 1, 16, 11, 304, 182, 57
	DQBbox 1, 17, 12, 303, 181, 3
	DQBboxf 1, 18, 13, 302, 180, 43
	DQBbox 1, 225, 10, 305, 128, 144
	DQBbox 1, 226, 11, 304, 127, 57
	DQBbox 1, 227, 12, 303, 126, 3
	DQBboxf 1, 228, 13, 302, 125, 43
	IF OPT = 0 THEN
		IF CURSOR = 1 THEN DQBPUT 1, 230, 25, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		IF CURSOR = 2 THEN DQBPUT 1, 230, 40, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		IF CURSOR = 3 THEN DQBPUT 1, 230, 55, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		IF CURSOR = 4 THEN DQBPUT 1, 230, 70, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		IF CURSOR = 5 THEN DQBPUT 1, 230, 85, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		IF CURSOR = 6 THEN DQBPUT 1, 230, 100, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		IF CURSOR = 7 THEN DQBPUT 1, 230, 115, VARSEG(POINTER(0)), VARPTR(POINTER(0))
	END IF
	IF OPT = 1 THEN
		IF CURSOR = 1 THEN
			DQBPUT 1, 50, 37, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 25, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 2 THEN
			DQBPUT 1, 50, 81, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 25, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 3 THEN
			DQBPUT 1, 50, 124, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 25, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
	END IF
	IF OPT = 2 THEN
		IF CURSOR = 1 THEN
			DQBPUT 1, 50, 37, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 40, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 2 THEN
			DQBPUT 1, 50, 81, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 40, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 3 THEN
			DQBPUT 1, 50, 124, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 40, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
	END IF
	IF OPT = 3 THEN
		IF CURSOR = 1 THEN
			DQBPUT 1, 50, 37, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 55, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 2 THEN
			DQBPUT 1, 50, 81, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 55, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 3 THEN
			DQBPUT 1, 50, 124, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 55, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
	END IF
	IF OPT = 4 THEN
		IF CURSOR = 1 THEN
			DQBPUT 1, 50, 37, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 70, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 2 THEN
			DQBPUT 1, 50, 81, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 70, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
		IF CURSOR = 3 THEN
			DQBPUT 1, 50, 124, VARSEG(POINTER(0)), VARPTR(POINTER(0))
			DQBPUT 1, 230, 70, VARSEG(POINTER(0)), VARPTR(POINTER(0))
		END IF
	END IF
	VPRINT 1, 249, 25, "Item", 3, 144, 8, 8, 2
	VPRINT 1, 251, 40, "Magic", 3, 144, 8, 8, 2
	VPRINT 1, 251, 55, "Equip", 3, 144, 8, 8, 2
	VPRINT 1, 251, 70, "Info", 3, 144, 8, 8, 2
	VPRINT 1, 251, 85, "Config", 3, 144, 8, 8, 2
	VPRINT 1, 251, 100, "Exit", 3, 144, 8, 8, 2
	VPRINT 1, 251, 115, "Return", 3, 144, 8, 8, 2
	DQBPUT 1, 80, 37, VARSEG(KRANG1A(0)), VARPTR(KRANG1A(0))
	DQBPUT 1, 80, 81, VARSEG(KOLDG1A(0)), VARPTR(KOLDG1A(0))
	DQBPUT 1, 80, 124, VARSEG(DAARG1A(0)), VARPTR(DAARG1A(0))
	VPRINT 1, 20, 20, KRANAR.NAMEID, 3, 144, 8, 8, 2
	VPRINT 1, 20, 29, "Level  " + STR$(KRANAR.LEVEL), 3, 144, 8, 8, 2
	VPRINT 1, 130, 38, "HP  " + STR$(KRANAR.CURHP) + " /" + STR$(KRANAR.TOTHP), 3, 144, 8, 8, 2
	VPRINT 1, 130, 47, "MP  " + STR$(KRANAR.CURMP) + " /" + STR$(KRANAR.TOTMP), 3, 144, 8, 8, 2
	VPRINT 1, 20, 63, KOLDERON.NAMEID, 3, 144, 8, 8, 2
	VPRINT 1, 20, 72, "Level  " + STR$(KOLDERON.LEVEL), 3, 144, 8, 8, 2
	VPRINT 1, 130, 81, "HP  " + STR$(KOLDERON.CURHP) + " /" + STR$(KOLDERON.TOTHP), 3, 144, 8, 8, 2
	VPRINT 1, 130, 90, "MP  " + STR$(KOLDERON.CURMP) + " /" + STR$(KOLDERON.TOTMP), 3, 144, 8, 8, 2
	VPRINT 1, 20, 106, DAARIUN.NAMEID, 3, 144, 8, 8, 2
	VPRINT 1, 20, 115, "Level  " + STR$(DAARIUN.LEVEL), 3, 144, 8, 8, 2
	VPRINT 1, 130, 124, "HP  " + STR$(DAARIUN.CURHP) + " /" + STR$(DAARIUN.TOTHP), 3, 144, 8, 8, 2
	VPRINT 1, 130, 133, "MP  " + STR$(DAARIUN.CURMP) + " /" + STR$(DAARIUN.TOTMP), 3, 144, 8, 8, 2
	DQBCOPYLAYER 1, VIDEO
	DO
	  IF DQBkey(KEYDOWN) THEN
		CURSOR = CURSOR + 1
		IF CURSOR = 8 AND OPT = 0 THEN CURSOR = 1
		IF CURSOR = 4 AND OPT = 1 THEN CURSOR = 1
		IF CURSOR = 4 AND OPT = 2 THEN CURSOR = 1
		IF CURSOR = 4 AND OPT = 3 THEN CURSOR = 1
		IF CURSOR = 4 AND OPT = 4 THEN CURSOR = 1
		WAITX! = TIMER
		DO: LOOP UNTIL TIMER - WAITX! > .25
		GOTO DRAWSCREEN
	  END IF
	  IF DQBkey(KEYUP) THEN
		CURSOR = CURSOR - 1
		IF CURSOR = 0 AND OPT = 0 THEN CURSOR = 7
		IF CURSOR = 0 AND OPT = 1 THEN CURSOR = 3
		IF CURSOR = 0 AND OPT = 2 THEN CURSOR = 3
		IF CURSOR = 0 AND OPT = 3 THEN CURSOR = 3
		IF CURSOR = 0 AND OPT = 4 THEN CURSOR = 3
		WAITX! = TIMER
		DO: LOOP UNTIL TIMER - WAITX! > .25
		GOTO DRAWSCREEN
	  END IF
	  IF DQBkey(KEYESC) THEN
		IF OPT = 1 THEN
			OPT = 0
			CURSOR = 1
			WAITX! = TIMER
			DO: LOOP UNTIL TIMER - WAITX! > .25
			GOTO DRAWSCREEN
		END IF
		IF OPT = 2 THEN
			OPT = 0
			CURSOR = 2
			WAITX! = TIMER
			DO: LOOP UNTIL TIMER - WAITX! > .25
			GOTO DRAWSCREEN
		END IF
		IF OPT = 3 THEN
			OPT = 0
			CURSOR = 3
			WAITX! = TIMER
			DO: LOOP UNTIL TIMER - WAITX! > .25
			GOTO DRAWSCREEN
		END IF
		IF OPT = 4 THEN
			OPT = 0
			CURSOR = 4
			WAITX! = TIMER
			DO: LOOP UNTIL TIMER - WAITX! > .25
			GOTO DRAWSCREEN
		END IF
	  END IF
	  IF DQBkey(KEYSPACE) THEN
		IF OPT = 0 THEN
		  IF CURSOR = 1 THEN
			  CURSOR = 1
			  OPT = 1
			  WAITX! = TIMER
			  DO: LOOP UNTIL TIMER - WAITX! > .25
			  GOTO DRAWSCREEN
		  END IF
		  IF CURSOR = 2 THEN
			  CURSOR = 1
			  OPT = 2
			  WAITX! = TIMER
			  DO: LOOP UNTIL TIMER - WAITX! > .25
			  GOTO DRAWSCREEN
		  END IF
		  IF CURSOR = 3 THEN
			  CURSOR = 1
			  OPT = 3
			  WAITX! = TIMER
			  DO: LOOP UNTIL TIMER - WAITX! > .25
			  GOTO DRAWSCREEN
		  END IF
		  IF CURSOR = 4 THEN
			  CURSOR = 1
			  OPT = 4
			  WAITX! = TIMER
			  DO: LOOP UNTIL TIMER - WAITX! > .25
			  GOTO DRAWSCREEN
		  END IF
		END IF
		IF OPT = 4 THEN
			WAITX! = TIMER
			DO: LOOP UNTIL TIMER - WAITX! > .25
			IF CURSOR = 1 THEN SHOWINFO KRANARC
			IF CURSOR = 2 THEN SHOWINFO KOLDERONC
			IF CURSOR = 3 THEN SHOWINFO DAARIUNC
		END IF
		IF CURSOR = 6 THEN
			ENDGAME = TRUE
			EXIT DO
		END IF
		IF CURSOR = 7 THEN
			FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
			ANIMATECHARACTER CHARD
			SHOWTILES TRUE
			FADEIN 0, 0, 255, RGBPAL(), PALMEM()
			EXIT DO
		END IF
	  END IF
	LOOP
END SUB

SUB INTRO
DIALOGBOX 1
ULTRAPRINT "Welcome to the Ultraverse...", 24, 125, 3, 144, 8, 8, 2
ULTRAPRINT "Push spacebar to proceed with", 22, 135, 3, 144, 8, 8, 2
ULTRAPRINT "dialog.", 22, 145, 3, 145, 8, 8, 2

DO: LOOP UNTIL DQBkey(KEYSPACE)

DIALOGBOX 1
ULTRAPRINT "Implemented in this version of", 24, 125, 3, 144, 8, 8, 2
ULTRAPRINT "the tilemap engine are the", 24, 135, 3, 144, 8, 8, 2
ULTRAPRINT "basic functions and effects", 24, 145, 3, 144, 8, 8, 2
ULTRAPRINT "which will be present in the", 24, 155, 3, 144, 8, 8, 2
ULTRAPRINT "final release of the Ultraverse.", 24, 165, 3, 144, 8, 8, 2
DO: LOOP UNTIL DQBkey(KEYSPACE)

DIALOGBOX 1
ULTRAPRINT "Push F1 to enter the inventory.", 24, 125, 3, 144, 8, 8, 2
ULTRAPRINT "You may exit the game at anytime", 24, 135, 3, 144, 8, 8, 2
ULTRAPRINT "from the inventory or view stats.", 24, 145, 3, 144, 8, 8, 2
ULTRAPRINT "In order to speak with a person,", 24, 155, 3, 144, 8, 8, 2
ULTRAPRINT "Walk under them and push spacebar", 24, 165, 3, 144, 8, 8, 2
DO: LOOP UNTIL DQBkey(KEYSPACE)

DIALOGBOX 1
ULTRAPRINT "E-mail questions and comments to:", 24, 125, 3, 144, 8, 8, 2
ULTRAPRINT "Chronomaster@home.net", 24, 135, 3, 144, 8, 8, 2
ULTRAPRINT "Please push spacebar to begin...", 24, 145, 3, 144, 8, 8, 2
DO: LOOP UNTIL DQBkey(KEYSPACE)

END SUB

SUB LOADCHAR
	IF KRANAR.GENERATION = 1 THEN
		DEF SEG = VARSEG(KRANG1A(0))
			BLOAD "GFX\KRANG1A.GFX", 0
		DEF SEG
		DEF SEG = VARSEG(KRANG1B(0))
			BLOAD "GFX\KRANG1B.GFX", 0
		DEF SEG
		DEF SEG = VARSEG(KRANG1C(0))
			BLOAD "GFX\KRANG1C.GFX", 0
		DEF SEG
	END IF
	IF KOLDERON.GENERATION = 1 THEN
		DEF SEG = VARSEG(KOLDG1A(0))
			BLOAD "GFX\KOLDG1A.GFX", 0
		DEF SEG
		DEF SEG = VARSEG(KOLDG1B(0))
			BLOAD "GFX\KOLDG1B.GFX", 0
		DEF SEG
		DEF SEG = VARSEG(KOLDG1C(0))
			BLOAD "GFX\KOLDG1C.GFX", 0
		DEF SEG
	END IF
	IF DAARIUN.GENERATION = 1 THEN
		DEF SEG = VARSEG(DAARG1A(0))
			BLOAD "GFX\DAARG1A.GFX", 0
		DEF SEG
		DEF SEG = VARSEG(DAARG1B(0))
			BLOAD "GFX\DAARG1B.GFX", 0
		DEF SEG
		DEF SEG = VARSEG(DAARG1C(0))
			BLOAD "GFX\DAARG1C.GFX", 0
		DEF SEG
	END IF
END SUB

SUB LOADHOTSPOT
	IF CHARFLAG = GLOBE THEN
		IF INT(WCOORX / 16) = 7 AND INT(WCOORY / 16) = 11 THEN
			FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
			WCOORX = 107: WCOORY = 190
			GCOORX = 100: GCOORY = 118
			LOADHOUSETILES
			LOADMAP "MAPS\TEST2.MAP": CHARFLAG = HOUSE
		END IF
		IF INT(WCOORX / 16) = 13 AND INT(WCOORY / 16) = 11 THEN
			FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
			WCOORX = 203: WCOORY = 190
			GCOORX = 196: GCOORY = 118
			LOADHOUSETILES
			LOADMAP "MAPS\TEST2.MAP": CHARFLAG = HOUSE
		END IF
	END IF
	IF CHARFLAG = HOUSE THEN
		IF INT(WCOORX / 16) = 6 AND INT(WCOORY / 16) = 13 THEN
			FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
			WCOORX = 113: WCOORY = 186
			GCOORX = 100: GCOORY = 118
			LOADTOWNTILES
			LOADMAP "MAPS\TEST1.MAP": CHARFLAG = GLOBE
		END IF
		IF INT(WCOORX / 16) = 12 AND INT(WCOORY / 16) = 13 THEN
			FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
			WCOORX = 209: WCOORY = 186
			GCOORX = 196: GCOORY = 118
			LOADTOWNTILES
			LOADMAP "MAPS\TEST1.MAP": CHARFLAG = GLOBE
		END IF
	END IF
END SUB

SUB LOADHOUSETILES
  LOADPAL "KRANAR.PAL"
  LOADCHAR
  DEF SEG = VARSEG(POINTER(0))
	BLOAD "POINTER.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKD1(0))
	BLOAD "KRANARD1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKD2(0))
	BLOAD "KRANARD2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKU1(0))
	BLOAD "KRANARU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKU2(0))
	BLOAD "KRANARU2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKR1(0))
	BLOAD "KRANARR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKR2(0))
	BLOAD "KRANARR2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKL1(0))
	BLOAD "KRANARL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKL2(0))
	BLOAD "KRANARL2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N1(0))
	BLOAD "WOODFLR.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N2(0))
	BLOAD "WOODFLR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N3(0))
	BLOAD "WOODFLR2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N4(0))
	BLOAD "WOODFLR3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N5(0))
	BLOAD "WOODFLR4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N6(0))
	BLOAD "WOODFLU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N7(0))
	BLOAD "WOODFLD1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N8(0))
	BLOAD "WOODFR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N9(0))
	BLOAD "WOODFL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N10(0))
	BLOAD "HOUSEWC1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N11(0))
	BLOAD "HOUSEWC2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N12(0))
	BLOAD "HOUSEWC3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N13(0))
	BLOAD "HOUSEWC4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N14(0))
	BLOAD "HOUSEWD1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N15(0))
	BLOAD "HOUSEWL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N16(0))
	BLOAD "HOUSEWR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N17(0))
	BLOAD "HOUSEWU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X3N1(0))
	BLOAD "WALLTL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X3N2(0))
	BLOAD "WALLU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X3N3(0))
	BLOAD "WALLTR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N1L2(0))
	BLOAD "HDOOR1.GFX", 0
  DEF SEG
END SUB

SUB LOADMAP (MAP$)
  FOR X = 0 TO 100
	FOR Y = 0 TO 100
		TILEMAPL1(X, Y) = 0
		TILEMAPL2(X, Y) = 0
		TILEWALK(X, Y) = 0
		CRITMAP(X, Y) = 0
	NEXT
  NEXT
  Filenum = FREEFILE
  OPEN MAP$ FOR INPUT AS Filenum
  INPUT #Filenum, MAPCOLUMNS, MAPROWS
  FOR y1 = 0 TO MAPROWS - 1
	FOR x1 = 0 TO MAPCOLUMNS - 1
	  INPUT #Filenum, TILEMAPL1(x1, y1)
	NEXT x1
  NEXT y1
  FOR y1 = 0 TO MAPROWS - 1
	FOR x1 = 0 TO MAPCOLUMNS - 1
	  INPUT #Filenum, TILEMAPL2(x1, y1)
	NEXT x1
  NEXT y1
  FOR y1 = 0 TO MAPROWS - 1
	FOR x1 = 0 TO MAPCOLUMNS - 1
	  INPUT #Filenum, TILEWALK(x1, y1)
	NEXT x1
  NEXT y1
  FOR y1 = 0 TO MAPROWS - 1
	FOR x1 = 0 TO MAPCOLUMNS - 1
	  INPUT #Filenum, CRITMAP(x1, y1)
	NEXT x1
  NEXT y1
  CLOSE #Filenum
END SUB

SUB LOADPAL (COLORS$)
IF COLORS$ = "" THEN GOTO endsub
OPEN COLORS$ FOR BINARY AS #1
 FOR Att = 0 TO 255
  OUT &H3C8, Att
   FOR RedGreenAndBlue = 1 TO 3
	GET #1, , BYTE
	Valew = ASC(BYTE)
	OUT &H3C9, Valew
   NEXT RedGreenAndBlue
 NEXT Att
CLOSE #1
endsub:
END SUB

SUB LOADTOWNTILES
  LOADPAL "KRANAR.PAL"
  LOADCHAR
  DEF SEG = VARSEG(POINTER(0))
	BLOAD "GFX\POINTER.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKD1(0))
	BLOAD "GFX\KRANARD1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKD2(0))
	BLOAD "GFX\KRANARD2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKU1(0))
	BLOAD "GFX\KRANARU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKU2(0))
	BLOAD "GFX\KRANARU2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKR1(0))
	BLOAD "GFX\KRANARR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKR2(0))
	BLOAD "GFX\KRANARR2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKL1(0))
	BLOAD "GFX\KRANARL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(LINKL2(0))
	BLOAD "GFX\KRANARL2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N1(0))
	BLOAD "GFX\GRASS1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N2(0))
	BLOAD "GFX\STEPST1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N3(0))
	BLOAD "GFX\GRASSHU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N4(0))
	BLOAD "GFX\GRASSHD1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N5(0))
	BLOAD "GFX\GRASSHL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N6(0))
	BLOAD "GFX\GRASSHR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N7(0))
	BLOAD "GFX\GRASSHC1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N8(0))
	BLOAD "GFX\GRASSHC2.GFX", 0
  DEF SEG

  DEF SEG = VARSEG(TILE1X1N9(0))
	BLOAD "GFX\GRASSHC3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N10(0))
	BLOAD "GFX\GRASSHC4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N11(0))
	BLOAD "GFX\GRASSHC5.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N12(0))
	BLOAD "GFX\GRASSHC6.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N13(0))
	BLOAD "GFX\GRASSHC7.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N14(0))
	BLOAD "GFX\GRASSHC8.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N15(0))
	BLOAD "GFX\GRASSHB1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N16(0))
	BLOAD "GFX\GRASSHB2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N17(0))
	BLOAD "GFX\BUSH1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N18(0))
	BLOAD "GFX\BUSH2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N19(0))
	BLOAD "GFX\BARREL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N20(0))
	BLOAD "GFX\BOX1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N21(0))
	BLOAD "GFX\FENCEB1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N22(0))
	BLOAD "GFX\FENCEU1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N23(0))
	BLOAD "GFX\FENCEL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N24(0))
	BLOAD "GFX\FENCER1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N25(0))
	BLOAD "GFX\FENCEC1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N26(0))
	BLOAD "GFX\FENCEC2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N27(0))
	BLOAD "GFX\FENCEC3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N28(0))
	BLOAD "GFX\FENCEC4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N29(0))
	BLOAD "GFX\TREEBOT1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N1(0))
	BLOAD "GFX\BWALL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N2(0))
	BLOAD "GFX\BWALL1L.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N3(0))
	BLOAD "GFX\BWALL1R.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N4(0))
	BLOAD "GFX\BWALL2L.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N5(0))
	BLOAD "GFX\BWALL2R.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N6(0))
	BLOAD "GFX\BWIN1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N7(0))
	BLOAD "GFX\BDOOR1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X3N1(0))
	BLOAD "GFX\BROOF4L.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X4N1(0))
	BLOAD "GFX\BROOFT2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X4N2(0))
	BLOAD "GFX\BROOFT3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X4N3(0))
	BLOAD "GFX\BROOFT4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X4N4(0))
	BLOAD "GFX\BROOFT5.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N1(0))
	BLOAD "GFX\BROOF2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N2(0))
	BLOAD "GFX\BROOF3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N3(0))
	BLOAD "GFX\BROOF3L.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N4(0))
	BLOAD "GFX\BROOF3R.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N5(0))
	BLOAD "GFX\BROOFW2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N6(0))
	BLOAD "GFX\BWIN2A.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N7(0))
	BLOAD "GFX\BWIN2B.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X2N1(0))
	BLOAD "GFX\BROOFW1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N1L2(0))
	BLOAD "GFX\TOWNP1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N2L2(0))
	BLOAD "GFX\TOWNP2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N3L2(0))
	BLOAD "GFX\TOWNP3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X1N4L2(0))
	BLOAD "GFX\TOWNP4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X3N1L2(0))
	BLOAD "GFX\TREETOP1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X4N1L2(0))
	BLOAD "GFX\BROOFT1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X2N1L2(0))
	BLOAD "GFX\TREEBUN1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X2N2L2(0))
	BLOAD "GFX\TREEBUN2.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X2N3L2(0))
	BLOAD "GFX\TREEBUN3.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X2N4L2(0))
	BLOAD "GFX\BROOFW1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N1L2(0))
	BLOAD "GFX\TREEBUN4.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE1X2N2L2(0))
	BLOAD "GFX\BWALL1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N1L2(0))
	BLOAD "GFX\BROOF1.GFX", 0
  DEF SEG
  DEF SEG = VARSEG(TILE2X1N2L2(0))
	BLOAD "GFX\BROOFW2.GFX", 0
  DEF SEG
END SUB

SUB PUTLAYER2 (DIRECTION)
	IF DIRECTION = NEUTRAL THEN
	FOR X = (WCOORX / 16) - (GCOORX / 16) TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 1 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), (X * 16) - WCOORX + GCOORX, (Y * 16) - WCOORY + GCOORY
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	EXIT SUB
	END IF
	IF CHARD = UP THEN
	FOR X = (WCOORX / 16) - (GCOORX / 16) TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 1 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), (X * 16) - WCOORX + GCOORX, ((Y * 16) - WCOORY + GCOORY) + 1
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	END IF
	IF CHARD = DOWN THEN
	FOR X = (WCOORX / 16) - (GCOORX / 16) TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 1 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), (X * 16) - WCOORX + GCOORX, ((Y * 16) - WCOORY + GCOORY) - 1
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	END IF
	IF CHARD = LEFT THEN
	FOR X = (WCOORX / 16) - (GCOORX / 16) TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 1 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), ((X * 16) - WCOORX + GCOORX) + 1, (Y * 16) - WCOORY + GCOORY
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	END IF
	IF CHARD = RIGHT THEN
	FOR X = (WCOORX / 16) - (GCOORX / 16) TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 1 TO (WCOORY / 16) - (GCOORY / 16) + 12
		 TILEPLACEL2 TILEMAPL2(X, Y), ((X * 16) - WCOORX + GCOORX) - 1, (Y * 16) - WCOORY + GCOORY
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	END IF
END SUB

REM $STATIC
SUB SAVEGAME
END SUB

REM $DYNAMIC
SUB SHOWINFO (CHAR)
	DQBbox 1, 15, 10, 305, 183, 144
	DQBbox 1, 16, 11, 304, 182, 57
	DQBbox 1, 17, 12, 303, 181, 3
	DQBboxf 1, 18, 13, 302, 180, 43
	IF CHAR = KRANARC THEN
		VPRINT 1, 29, 20, KRANAR.NAMEID, 3, 144, 8, 8, 2
		VPRINT 1, 140, 20, "Level " + STR$(KRANAR.LEVEL), 3, 144, 8, 8, 2
		VPRINT 1, 29, 30, "Generation " + STR$(KRANAR.GENERATION), 3, 144, 8, 8, 2
		DQBPUT 1, 110, 50, VARSEG(KRANG1A(0)), VARPTR(KRANG1A(0))
		VPRINT 1, 29, 80, "STR  - " + STR$(KRANAR.STR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 90, "REF  - " + STR$(KRANAR.STR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 100, "AUR  - " + STR$(KRANAR.STR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 110, "WIS  - " + STR$(KRANAR.STR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 120, "WIL  - " + STR$(KRANAR.STR), 3, 144, 8, 8, 2
		VPRINT 1, 140, 80, "Weapon Skill  - " + STR$(KRANAR.WEAPONSKILL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 90, "Shield Skill  - " + STR$(KRANAR.SHIELDSKILL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 100, "Spell Power   - " + STR$(KRANAR.SPELLPOWER), 3, 144, 8, 8, 2
		VPRINT 1, 140, 110, "Encumberance  - " + STR$(KRANAR.ENCUMBER), 3, 144, 8, 8, 2
		VPRINT 1, 140, 120, "Total Armor   - " + STR$(KRANAR.PROTECTION), 3, 144, 8, 8, 2
		VPRINT 1, 29, 140, "Tot Exps    - " + STR$(KRANAR.EXPER), 3, 144, 8, 8, 2
		VPRINT 1, 29, 150, "Exps Needed - " + STR$(KRANAR.EXPERNEED), 3, 144, 8, 8, 2
		VPRINT 1, 190, 140, "HP " + STR$(KRANAR.CURHP) + "/" + STR$(KRANAR.TOTHP), 3, 144, 8, 8, 2
		VPRINT 1, 190, 150, "MP " + STR$(KRANAR.CURMP) + "/" + STR$(KRANAR.TOTMP), 3, 144, 8, 8, 2
	END IF
	IF CHAR = KOLDERONC THEN
		VPRINT 1, 29, 20, KOLDERON.NAMEID, 3, 144, 8, 8, 2
		VPRINT 1, 140, 20, "Level " + STR$(KOLDERON.LEVEL), 3, 144, 8, 8, 2
		VPRINT 1, 29, 30, "Generation " + STR$(KOLDERON.GENERATION), 3, 144, 8, 8, 2
		DQBPUT 1, 110, 50, VARSEG(KOLDG1A(0)), VARPTR(KOLDG1A(0))
		VPRINT 1, 29, 80, "STR  - " + STR$(KOLDERON.STR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 90, "REF  - " + STR$(KOLDERON.REF), 3, 144, 8, 8, 2
		VPRINT 1, 29, 100, "AUR  - " + STR$(KOLDERON.AUR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 110, "WIS  - " + STR$(KOLDERON.WIS), 3, 144, 8, 8, 2
		VPRINT 1, 29, 120, "WIL  - " + STR$(KOLDERON.WIL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 80, "Weapon Skill  - " + STR$(KOLDERON.WEAPONSKILL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 90, "Shield Skill  - " + STR$(KOLDERON.SHIELDSKILL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 100, "Spell Power   - " + STR$(KOLDERON.SPELLPOWER), 3, 144, 8, 8, 2
		VPRINT 1, 140, 110, "Encumberance  - " + STR$(KOLDERON.ENCUMBER), 3, 144, 8, 8, 2
		VPRINT 1, 140, 120, "Total Armor   - " + STR$(KOLDERON.PROTECTION), 3, 144, 8, 8, 2
		VPRINT 1, 29, 140, "Tot Exps    - " + STR$(KOLDERON.EXPER), 3, 144, 8, 8, 2
		VPRINT 1, 29, 150, "Exps Needed - " + STR$(KOLDERON.EXPERNEED), 3, 144, 8, 8, 2
		VPRINT 1, 190, 140, "HP " + STR$(KOLDERON.CURHP) + "/" + STR$(KOLDERON.TOTHP), 3, 144, 8, 8, 2
		VPRINT 1, 190, 150, "MP " + STR$(KOLDERON.CURMP) + "/" + STR$(KOLDERON.TOTMP), 3, 144, 8, 8, 2
	END IF
	IF CHAR = DAARIUNC THEN
		VPRINT 1, 29, 20, DAARIUN.NAMEID, 3, 144, 8, 8, 2
		VPRINT 1, 140, 20, "Level " + STR$(DAARIUN.LEVEL), 3, 144, 8, 8, 2
		VPRINT 1, 29, 30, "Generation " + STR$(DAARIUN.GENERATION), 3, 144, 8, 8, 2
		DQBPUT 1, 110, 50, VARSEG(DAARG1A(0)), VARPTR(DAARG1A(0))
		VPRINT 1, 29, 80, "STR  - " + STR$(DAARIUN.STR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 90, "REF  - " + STR$(DAARIUN.REF), 3, 144, 8, 8, 2
		VPRINT 1, 29, 100, "AUR  - " + STR$(DAARIUN.AUR), 3, 144, 8, 8, 2
		VPRINT 1, 29, 110, "WIS  - " + STR$(DAARIUN.WIS), 3, 144, 8, 8, 2
		VPRINT 1, 29, 120, "WIL  - " + STR$(DAARIUN.WIL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 80, "Weapon Skill  - " + STR$(DAARIUN.WEAPONSKILL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 90, "Shield Skill  - " + STR$(DAARIUN.SHIELDSKILL), 3, 144, 8, 8, 2
		VPRINT 1, 140, 100, "Spell Power   - " + STR$(DAARIUN.SPELLPOWER), 3, 144, 8, 8, 2
		VPRINT 1, 140, 110, "Encumberance  - " + STR$(DAARIUN.ENCUMBER), 3, 144, 8, 8, 2
		VPRINT 1, 140, 120, "Total Armor   - " + STR$(DAARIUN.PROTECTION), 3, 144, 8, 8, 2
		VPRINT 1, 29, 140, "Tot Exps    - " + STR$(DAARIUN.EXPER), 3, 144, 8, 8, 2
		VPRINT 1, 29, 150, "Exps Needed - " + STR$(DAARIUN.EXPERNEED), 3, 144, 8, 8, 2
		VPRINT 1, 190, 140, "HP " + STR$(DAARIUN.CURHP) + "/" + STR$(DAARIUN.TOTHP), 3, 144, 8, 8, 2
		VPRINT 1, 190, 150, "MP " + STR$(DAARIUN.CURMP) + "/" + STR$(DAARIUN.TOTMP), 3, 144, 8, 8, 2
	END IF
	DQBCOPYLAYER 1, VIDEO
END SUB

SUB SHOWTILES (DISPLAY)
  FOR X = (WCOORX / 16) - (GCOORX / 16) - 4 TO (WCOORX / 16) - (GCOORX / 16) + 19
	FOR Y = (WCOORY / 16) - (GCOORY / 16) - 4 TO (WCOORY / 16) - (GCOORY / 16) + 12
	  TILEPLACEL1 TILEMAPL1(X, Y), (X * 16) - WCOORX + GCOORX, (Y * 16) - WCOORY + GCOORY
	NEXT
  NEXT
  DQBboxf 1, 0, 0, 320, 16, 0
  DQBboxf 1, 0, 184, 320, 200, 0
  DQBboxf 1, 0, 0, 16, 200, 0
  DQBboxf 1, 304, 0, 320, 200, 0
  IF DISPLAY = TRUE AND FRAMESET = FALSE AND CHARD = LEFT THEN
	DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKL1(0)), VARPTR(LINKL1(0))
	FOR X = (WCOORX / 16) - (GCOORX / 16) - 4 TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 4 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), (X * 16) - WCOORX + GCOORX, (Y * 16) - WCOORY + GCOORY
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	DQBCOPYLAYER 1, VIDEO
	DQBCLEARLAYER 1
  END IF
  IF DISPLAY = TRUE AND FRAMESET = FALSE AND CHARD = RIGHT THEN
	DQBPUT 1, GCOORX, GCOORY, VARSEG(LINKR1(0)), VARPTR(LINKR1(0))
	FOR X = (WCOORX / 16) - (GCOORX / 16) - 4 TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 4 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), (X * 16) - WCOORX + GCOORX, (Y * 16) - WCOORY + GCOORY
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	DQBCOPYLAYER 1, VIDEO
	DQBCLEARLAYER 1
  END IF
  IF DISPLAY = FALSE OR DISPLAY <> TRUE THEN
	FOR X = (WCOORX / 16) - (GCOORX / 16) - 4 TO (WCOORX / 16) - (GCOORX / 16) + 19
	  FOR Y = (WCOORY / 16) - (GCOORY / 16) - 4 TO (WCOORY / 16) - (GCOORY / 16) + 12
		TILEPLACEL2 TILEMAPL2(X, Y), (X * 16) - WCOORX + GCOORX, (Y * 16) - WCOORY + GCOORY
	  NEXT
	NEXT
	DQBboxf 1, 0, 0, 320, 16, 0
	DQBboxf 1, 0, 184, 320, 200, 0
	DQBboxf 1, 0, 0, 16, 200, 0
	DQBboxf 1, 304, 0, 320, 200, 0
	EXIT SUB
  END IF
END SUB

SUB SPLASH
  DIM SPLASH1(20000)
  DIM SPLASH2(20000)
  LOADPAL "SPLASH.PAL"
  OUT &H3C8, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  OUT &H3C9, 0
  DEF SEG = VARSEG(SPLASH1(0)): BLOAD "GFX\SPLASH1.GFX", 0: DEF SEG
  DEF SEG = VARSEG(SPLASH2(0)): BLOAD "GFX\SPLASH2.GFX", 0: DEF SEG
  YPLACE = 200: SP = 12
  DO
     YPLACE = YPLACE - 1
     DQBPUT 1, 0, 0, VARSEG(SPLASH1(0)), VARPTR(SPLASH1(0))
     DQBPUT 1, 160, 0, VARSEG(SPLASH2(0)), VARPTR(SPLASH2(0))
     VPRINT 1, 104, YPLACE, "THE ULTRAVERSE", 40, 23, 8, 8, 2
     OPEN "MAPS\DUMP.BIN" FOR INPUT AS #1
     DO WHILE NOT EOF(1)
	LINE INPUT #1, STORY$
	XPLACE = XPLACE + 1
	VPRINT 1, 0, YPLACE + 20 + (SP * XPLACE), STORY$, 40, 23, 8, 8, 2
     LOOP
     CLOSE #1
     XPLACE = 0
     DQBCOPYLAYER 1, VIDEO
  LOOP UNTIL DQBkey(KEYESC) OR YPLACE = -345
  ERASE SPLASH1, SPLASH2
  FADEOUT 0, 0, 255, RGBPAL(), PALMEM()
  DQBCLEARLAYER 1
  DQBCLEARLAYER VIDEO
END SUB

SUB TILEPLACEL1 (TILE, X, Y)
  SELECT CASE TILE
	CASE 0
	  EXIT SUB
	CASE 1
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N1(0)), VARPTR(TILE1X1N1(0))
	  EXIT SUB
	CASE 2
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N2(0)), VARPTR(TILE1X1N2(0))
	  EXIT SUB
	CASE 3
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N3(0)), VARPTR(TILE1X1N3(0))
	  EXIT SUB
	CASE 4
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N4(0)), VARPTR(TILE1X1N4(0))
	  EXIT SUB
	CASE 5
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N5(0)), VARPTR(TILE1X1N5(0))
	  EXIT SUB
	CASE 6
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N6(0)), VARPTR(TILE1X1N6(0))
	  EXIT SUB
	CASE 7
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N7(0)), VARPTR(TILE1X1N7(0))
	  EXIT SUB
	CASE 8
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N8(0)), VARPTR(TILE1X1N8(0))
	  EXIT SUB
	CASE 9
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N9(0)), VARPTR(TILE1X1N9(0))
	  EXIT SUB
	CASE 10
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N10(0)), VARPTR(TILE1X1N10(0))
	  EXIT SUB
	CASE 11
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N11(0)), VARPTR(TILE1X1N11(0))
	  EXIT SUB
	CASE 12
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N12(0)), VARPTR(TILE1X1N12(0))
	  EXIT SUB
	CASE 13
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N13(0)), VARPTR(TILE1X1N13(0))
	  EXIT SUB
	CASE 14
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N14(0)), VARPTR(TILE1X1N14(0))
	  EXIT SUB
	CASE 15
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N15(0)), VARPTR(TILE1X1N15(0))
	  EXIT SUB
	CASE 16
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N16(0)), VARPTR(TILE1X1N16(0))
	  EXIT SUB
	CASE 17
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N17(0)), VARPTR(TILE1X1N17(0))
	  EXIT SUB
	CASE 18
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N18(0)), VARPTR(TILE1X1N18(0))
	  EXIT SUB
	CASE 19
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N19(0)), VARPTR(TILE1X1N19(0))
	  EXIT SUB
	CASE 20
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N20(0)), VARPTR(TILE1X1N20(0))
	  EXIT SUB
	CASE 21
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N21(0)), VARPTR(TILE1X1N21(0))
	  EXIT SUB
	CASE 22
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N22(0)), VARPTR(TILE1X1N22(0))
	  EXIT SUB
	CASE 23
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N23(0)), VARPTR(TILE1X1N23(0))
	  EXIT SUB
	CASE 24
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N24(0)), VARPTR(TILE1X1N24(0))
	  EXIT SUB
	CASE 25
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N25(0)), VARPTR(TILE1X1N25(0))
	  EXIT SUB
	CASE 26
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N26(0)), VARPTR(TILE1X1N26(0))
	  EXIT SUB
	CASE 27
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N27(0)), VARPTR(TILE1X1N27(0))
	  EXIT SUB
	CASE 28
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N28(0)), VARPTR(TILE1X1N28(0))
	  EXIT SUB
	CASE 29
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N29(0)), VARPTR(TILE1X1N29(0))
	  EXIT SUB
	CASE 30
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N30(0)), VARPTR(TILE1X1N30(0))
	  EXIT SUB
	CASE 31
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N31(0)), VARPTR(TILE1X1N31(0))
	  EXIT SUB
	CASE 32
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N32(0)), VARPTR(TILE1X1N32(0))
	  EXIT SUB
	CASE 33
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N33(0)), VARPTR(TILE1X1N33(0))
	  EXIT SUB
	CASE 34
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N34(0)), VARPTR(TILE1X1N34(0))
	  EXIT SUB
	CASE 35
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N35(0)), VARPTR(TILE1X1N35(0))
	  EXIT SUB
	CASE 36
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N36(0)), VARPTR(TILE1X1N36(0))
	  EXIT SUB
	CASE 37
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N37(0)), VARPTR(TILE1X1N37(0))
	  EXIT SUB
	CASE 38
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N38(0)), VARPTR(TILE1X1N38(0))
	  EXIT SUB
	CASE 39
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N39(0)), VARPTR(TILE1X1N39(0))
	  EXIT SUB
	CASE 40
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N40(0)), VARPTR(TILE1X1N40(0))
	  EXIT SUB
	CASE 41
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N41(0)), VARPTR(TILE1X1N41(0))
	  EXIT SUB
	CASE 42
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N42(0)), VARPTR(TILE1X1N42(0))
	  EXIT SUB
	CASE 43
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N43(0)), VARPTR(TILE1X1N43(0))
	  EXIT SUB
	CASE 44
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N44(0)), VARPTR(TILE1X1N44(0))
	  EXIT SUB
	CASE 45
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N45(0)), VARPTR(TILE1X1N45(0))
	  EXIT SUB
	CASE 46
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N46(0)), VARPTR(TILE1X1N46(0))
	  EXIT SUB
	CASE 47
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N47(0)), VARPTR(TILE1X1N47(0))
	  EXIT SUB
	CASE 48
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N48(0)), VARPTR(TILE1X1N48(0))
	  EXIT SUB
	CASE 49
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N49(0)), VARPTR(TILE1X1N49(0))
	  EXIT SUB
	CASE 50
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N50(0)), VARPTR(TILE1X1N50(0))
	  EXIT SUB
	CASE 51
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N1(0)), VARPTR(TILE1X2N1(0))
	  EXIT SUB
	CASE 52
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N2(0)), VARPTR(TILE1X2N2(0))
	  EXIT SUB
	CASE 53
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N3(0)), VARPTR(TILE1X2N3(0))
	  EXIT SUB
	CASE 54
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N4(0)), VARPTR(TILE1X2N4(0))
	  EXIT SUB
	CASE 55
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N5(0)), VARPTR(TILE1X2N5(0))
	  EXIT SUB
	CASE 56
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N6(0)), VARPTR(TILE1X2N6(0))
	  EXIT SUB
	CASE 57
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N7(0)), VARPTR(TILE1X2N7(0))
	  EXIT SUB
	CASE 58
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N8(0)), VARPTR(TILE1X2N8(0))
	  EXIT SUB
	CASE 59
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N9(0)), VARPTR(TILE1X2N9(0))
	  EXIT SUB
	CASE 60
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N10(0)), VARPTR(TILE1X2N10(0))
	  EXIT SUB
	CASE 61
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N11(0)), VARPTR(TILE1X2N11(0))
	  EXIT SUB
	CASE 62
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N12(0)), VARPTR(TILE1X2N12(0))
	  EXIT SUB
	CASE 63
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N13(0)), VARPTR(TILE1X2N13(0))
	  EXIT SUB
	CASE 64
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N14(0)), VARPTR(TILE1X2N14(0))
	  EXIT SUB
	CASE 65
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N15(0)), VARPTR(TILE1X2N15(0))
	  EXIT SUB
	CASE 66
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N16(0)), VARPTR(TILE1X2N16(0))
	  EXIT SUB
	CASE 67
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N17(0)), VARPTR(TILE1X2N17(0))
	  EXIT SUB
	CASE 68
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N18(0)), VARPTR(TILE1X2N18(0))
	  EXIT SUB
	CASE 69
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N19(0)), VARPTR(TILE1X2N19(0))
	  EXIT SUB
	CASE 70
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N20(0)), VARPTR(TILE1X2N20(0))
	  EXIT SUB
	CASE 71
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N1(0)), VARPTR(TILE1X3N1(0))
	  EXIT SUB
	CASE 72
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N2(0)), VARPTR(TILE1X3N2(0))
	  EXIT SUB
	CASE 73
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N3(0)), VARPTR(TILE1X3N3(0))
	  EXIT SUB
	CASE 74
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N4(0)), VARPTR(TILE1X3N4(0))
	  EXIT SUB
	CASE 75
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N5(0)), VARPTR(TILE1X3N5(0))
	  EXIT SUB
	CASE 76
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N6(0)), VARPTR(TILE1X3N6(0))
	  EXIT SUB
	CASE 77
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N7(0)), VARPTR(TILE1X3N7(0))
	  EXIT SUB
	CASE 78
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N8(0)), VARPTR(TILE1X3N8(0))
	  EXIT SUB
	CASE 79
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N9(0)), VARPTR(TILE1X3N9(0))
	  EXIT SUB
	CASE 80
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N10(0)), VARPTR(TILE1X3N10(0))
	  EXIT SUB
	CASE 81
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N11(0)), VARPTR(TILE1X3N11(0))
	  EXIT SUB
	CASE 82
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N12(0)), VARPTR(TILE1X3N12(0))
	  EXIT SUB
	CASE 83
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N13(0)), VARPTR(TILE1X3N13(0))
	  EXIT SUB
	CASE 84
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N14(0)), VARPTR(TILE1X3N14(0))
	  EXIT SUB
	CASE 85
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N15(0)), VARPTR(TILE1X3N15(0))
	  EXIT SUB
	CASE 86
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N16(0)), VARPTR(TILE1X3N16(0))
	  EXIT SUB
	CASE 87
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N17(0)), VARPTR(TILE1X3N17(0))
	  EXIT SUB
	CASE 88
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N18(0)), VARPTR(TILE1X3N18(0))
	  EXIT SUB
	CASE 89
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N19(0)), VARPTR(TILE1X3N19(0))
	  EXIT SUB
	CASE 90
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N20(0)), VARPTR(TILE1X3N20(0))
	  EXIT SUB
	CASE 91
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N1(0)), VARPTR(TILE1X4N1(0))
	  EXIT SUB
	CASE 92
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N2(0)), VARPTR(TILE1X4N2(0))
	  EXIT SUB
	CASE 93
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N3(0)), VARPTR(TILE1X4N3(0))
	  EXIT SUB
	CASE 94
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N4(0)), VARPTR(TILE1X4N4(0))
	  EXIT SUB
	CASE 95
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N5(0)), VARPTR(TILE1X4N5(0))
	  EXIT SUB
	CASE 96
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N6(0)), VARPTR(TILE1X4N6(0))
	  EXIT SUB
	CASE 97
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N7(0)), VARPTR(TILE1X4N7(0))
	  EXIT SUB
	CASE 98
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N8(0)), VARPTR(TILE1X4N8(0))
	  EXIT SUB
	CASE 99
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N9(0)), VARPTR(TILE1X4N9(0))
	  EXIT SUB
	CASE 100
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N10(0)), VARPTR(TILE1X4N10(0))
	  EXIT SUB
	CASE 101
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N11(0)), VARPTR(TILE1X4N11(0))
	  EXIT SUB
	CASE 102
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N12(0)), VARPTR(TILE1X4N12(0))
	  EXIT SUB
	CASE 103
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N13(0)), VARPTR(TILE1X4N13(0))
	  EXIT SUB
	CASE 104
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N14(0)), VARPTR(TILE1X4N14(0))
	  EXIT SUB
	CASE 105
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N15(0)), VARPTR(TILE1X4N15(0))
	  EXIT SUB
	CASE 106
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N16(0)), VARPTR(TILE1X4N16(0))
	  EXIT SUB
	CASE 107
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N17(0)), VARPTR(TILE1X4N17(0))
	  EXIT SUB
	CASE 108
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N18(0)), VARPTR(TILE1X4N18(0))
	  EXIT SUB
	CASE 109
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N19(0)), VARPTR(TILE1X4N19(0))
	  EXIT SUB
	CASE 110
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N20(0)), VARPTR(TILE1X4N20(0))
	  EXIT SUB
	CASE 111
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N1(0)), VARPTR(TILE2X1N1(0))
	  EXIT SUB
	CASE 112
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N2(0)), VARPTR(TILE2X1N2(0))
	  EXIT SUB
	CASE 113
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N3(0)), VARPTR(TILE2X1N3(0))
	  EXIT SUB
	CASE 114
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N4(0)), VARPTR(TILE2X1N4(0))
	  EXIT SUB
	CASE 115
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N5(0)), VARPTR(TILE2X1N5(0))
	  EXIT SUB
	CASE 116
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N6(0)), VARPTR(TILE2X1N6(0))
	  EXIT SUB
	CASE 117
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N7(0)), VARPTR(TILE2X1N7(0))
	  EXIT SUB
	CASE 118
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N8(0)), VARPTR(TILE2X1N8(0))
	  EXIT SUB
	CASE 119
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N9(0)), VARPTR(TILE2X1N9(0))
	  EXIT SUB
	CASE 120
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N10(0)), VARPTR(TILE2X1N10(0))
	  EXIT SUB
	CASE 121
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N11(0)), VARPTR(TILE2X1N11(0))
	  EXIT SUB
	CASE 122
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N12(0)), VARPTR(TILE2X1N12(0))
	  EXIT SUB
	CASE 123
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N13(0)), VARPTR(TILE2X1N13(0))
	  EXIT SUB
	CASE 124
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N14(0)), VARPTR(TILE2X1N14(0))
	  EXIT SUB
	CASE 125
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N15(0)), VARPTR(TILE2X1N15(0))
	  EXIT SUB
	CASE 126
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N16(0)), VARPTR(TILE2X1N16(0))
	  EXIT SUB
	CASE 127
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N17(0)), VARPTR(TILE2X1N17(0))
	  EXIT SUB
	CASE 128
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N18(0)), VARPTR(TILE2X1N18(0))
	  EXIT SUB
	CASE 129
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N19(0)), VARPTR(TILE2X1N19(0))
	  EXIT SUB
	CASE 130
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N20(0)), VARPTR(TILE2X1N20(0))
	  EXIT SUB
	CASE 131
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N1(0)), VARPTR(TILE2X2N1(0))
	  EXIT SUB
	CASE 132
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N2(0)), VARPTR(TILE2X2N2(0))
	  EXIT SUB
	CASE 133
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N3(0)), VARPTR(TILE2X2N3(0))
	  EXIT SUB
	CASE 134
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N4(0)), VARPTR(TILE2X2N4(0))
	  EXIT SUB
	CASE 135
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N5(0)), VARPTR(TILE2X2N5(0))
	  EXIT SUB
	CASE 136
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N6(0)), VARPTR(TILE2X2N6(0))
	  EXIT SUB
	CASE 137
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N7(0)), VARPTR(TILE2X2N7(0))
	  EXIT SUB
	CASE 138
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N8(0)), VARPTR(TILE2X2N8(0))
	  EXIT SUB
	CASE 139
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N9(0)), VARPTR(TILE2X2N9(0))
	  EXIT SUB
	CASE 140
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N10(0)), VARPTR(TILE2X2N10(0))
	  EXIT SUB
	CASE 141
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N11(0)), VARPTR(TILE2X2N11(0))
	  EXIT SUB
	CASE 142
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N12(0)), VARPTR(TILE2X2N12(0))
	  EXIT SUB
	CASE 143
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N13(0)), VARPTR(TILE2X2N13(0))
	  EXIT SUB
	CASE 144
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N14(0)), VARPTR(TILE2X2N14(0))
	  EXIT SUB
	CASE 145
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N15(0)), VARPTR(TILE2X2N15(0))
	  EXIT SUB
	CASE 146
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N16(0)), VARPTR(TILE2X2N16(0))
	  EXIT SUB
	CASE 147
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N17(0)), VARPTR(TILE2X2N17(0))
	  EXIT SUB
	CASE 148
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N18(0)), VARPTR(TILE2X2N18(0))
	  EXIT SUB
	CASE 149
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N19(0)), VARPTR(TILE2X2N19(0))
	  EXIT SUB
	CASE 150
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N20(0)), VARPTR(TILE2X2N20(0))
	  EXIT SUB
  END SELECT
END SUB

SUB TILEPLACEL2 (TILE, X, Y)
  SELECT CASE TILE
	CASE 0
	  EXIT SUB
	CASE 1
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N1L2(0)), VARPTR(TILE1X1N1L2(0))
	  EXIT SUB
	CASE 2
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N2L2(0)), VARPTR(TILE1X1N2L2(0))
	  EXIT SUB
	CASE 3
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N3L2(0)), VARPTR(TILE1X1N3L2(0))
	  EXIT SUB
	CASE 4
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N4L2(0)), VARPTR(TILE1X1N4L2(0))
	  EXIT SUB
	CASE 5
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N5L2(0)), VARPTR(TILE1X1N5L2(0))
	  EXIT SUB
	CASE 6
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N6L2(0)), VARPTR(TILE1X1N6L2(0))
	  EXIT SUB
	CASE 7
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N7L2(0)), VARPTR(TILE1X1N7L2(0))
	  EXIT SUB
	CASE 8
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N8L2(0)), VARPTR(TILE1X1N8L2(0))
	  EXIT SUB
	CASE 9
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N9L2(0)), VARPTR(TILE1X1N9L2(0))
	  EXIT SUB
	CASE 10
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N10L2(0)), VARPTR(TILE1X1N10L2(0))
	  EXIT SUB
	CASE 11
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N11L2(0)), VARPTR(TILE1X1N11L2(0))
	  EXIT SUB
	CASE 12
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N12L2(0)), VARPTR(TILE1X1N12L2(0))
	  EXIT SUB
	CASE 13
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N13L2(0)), VARPTR(TILE1X1N13L2(0))
	  EXIT SUB
	CASE 14
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N14L2(0)), VARPTR(TILE1X1N14L2(0))
	  EXIT SUB
	CASE 15
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N15L2(0)), VARPTR(TILE1X1N15L2(0))
	  EXIT SUB
	CASE 16
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N16L2(0)), VARPTR(TILE1X1N16L2(0))
	  EXIT SUB
	CASE 17
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N17L2(0)), VARPTR(TILE1X1N17L2(0))
	  EXIT SUB
	CASE 18
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N18L2(0)), VARPTR(TILE1X1N18L2(0))
	  EXIT SUB
	CASE 19
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N19L2(0)), VARPTR(TILE1X1N19L2(0))
	  EXIT SUB
	CASE 20
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N20L2(0)), VARPTR(TILE1X1N20L2(0))
	  EXIT SUB
	CASE 21
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N21L2(0)), VARPTR(TILE1X1N21L2(0))
	  EXIT SUB
	CASE 22
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N22L2(0)), VARPTR(TILE1X1N22L2(0))
	  EXIT SUB
	CASE 23
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N23L2(0)), VARPTR(TILE1X1N23L2(0))
	  EXIT SUB
	CASE 24
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N24L2(0)), VARPTR(TILE1X1N24L2(0))
	  EXIT SUB
	CASE 25
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N25L2(0)), VARPTR(TILE1X1N25L2(0))
	  EXIT SUB
	CASE 26
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N26L2(0)), VARPTR(TILE1X1N26L2(0))
	  EXIT SUB
	CASE 27
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N27L2(0)), VARPTR(TILE1X1N27L2(0))
	  EXIT SUB
	CASE 28
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N28L2(0)), VARPTR(TILE1X1N28L2(0))
	  EXIT SUB
	CASE 29
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N29L2(0)), VARPTR(TILE1X1N29L2(0))
	  EXIT SUB
	CASE 30
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N30L2(0)), VARPTR(TILE1X1N30L2(0))
	  EXIT SUB
	CASE 31
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N31L2(0)), VARPTR(TILE1X1N31L2(0))
	  EXIT SUB
	CASE 32
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N32L2(0)), VARPTR(TILE1X1N32L2(0))
	  EXIT SUB
	CASE 33
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N33L2(0)), VARPTR(TILE1X1N33L2(0))
	  EXIT SUB
	CASE 34
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N34L2(0)), VARPTR(TILE1X1N34L2(0))
	  EXIT SUB
	CASE 35
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N35L2(0)), VARPTR(TILE1X1N35L2(0))
	  EXIT SUB
	CASE 36
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N36L2(0)), VARPTR(TILE1X1N36L2(0))
	  EXIT SUB
	CASE 37
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N37L2(0)), VARPTR(TILE1X1N37L2(0))
	  EXIT SUB
	CASE 38
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N38L2(0)), VARPTR(TILE1X1N38L2(0))
	  EXIT SUB
	CASE 39
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N39L2(0)), VARPTR(TILE1X1N39L2(0))
	  EXIT SUB
	CASE 40
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N40L2(0)), VARPTR(TILE1X1N40L2(0))
	  EXIT SUB
	CASE 41
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N41L2(0)), VARPTR(TILE1X1N41L2(0))
	  EXIT SUB
	CASE 42
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N42L2(0)), VARPTR(TILE1X1N42L2(0))
	  EXIT SUB
	CASE 43
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N43L2(0)), VARPTR(TILE1X1N43L2(0))
	  EXIT SUB
	CASE 44
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N44L2(0)), VARPTR(TILE1X1N44L2(0))
	  EXIT SUB
	CASE 45
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N45L2(0)), VARPTR(TILE1X1N45L2(0))
	  EXIT SUB
	CASE 46
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N46L2(0)), VARPTR(TILE1X1N46L2(0))
	  EXIT SUB
	CASE 47
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N47L2(0)), VARPTR(TILE1X1N47L2(0))
	  EXIT SUB
	CASE 48
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N48L2(0)), VARPTR(TILE1X1N48L2(0))
	  EXIT SUB
	CASE 49
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N49L2(0)), VARPTR(TILE1X1N49L2(0))
	  EXIT SUB
	CASE 50
	  DQBPUT 1, X, Y, VARSEG(TILE1X1N50L2(0)), VARPTR(TILE1X1N50L2(0))
	  EXIT SUB
	CASE 51
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N1L2(0)), VARPTR(TILE1X2N1L2(0))
	  EXIT SUB
	CASE 52
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N2L2(0)), VARPTR(TILE1X2N2L2(0))
	  EXIT SUB
	CASE 53
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N3L2(0)), VARPTR(TILE1X2N3L2(0))
	  EXIT SUB
	CASE 54
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N4L2(0)), VARPTR(TILE1X2N4L2(0))
	  EXIT SUB
	CASE 55
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N5L2(0)), VARPTR(TILE1X2N5L2(0))
	  EXIT SUB
	CASE 56
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N6L2(0)), VARPTR(TILE1X2N6L2(0))
	  EXIT SUB
	CASE 57
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N7L2(0)), VARPTR(TILE1X2N7L2(0))
	  EXIT SUB
	CASE 58
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N8L2(0)), VARPTR(TILE1X2N8L2(0))
	  EXIT SUB
	CASE 59
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N9L2(0)), VARPTR(TILE1X2N9L2(0))
	  EXIT SUB
	CASE 60
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N10L2(0)), VARPTR(TILE1X2N10L2(0))
	  EXIT SUB
	CASE 61
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N11L2(0)), VARPTR(TILE1X2N11L2(0))
	  EXIT SUB
	CASE 62
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N12L2(0)), VARPTR(TILE1X2N12L2(0))
	  EXIT SUB
	CASE 63
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N13L2(0)), VARPTR(TILE1X2N13L2(0))
	  EXIT SUB
	CASE 64
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N14L2(0)), VARPTR(TILE1X2N14L2(0))
	  EXIT SUB
	CASE 65
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N15L2(0)), VARPTR(TILE1X2N15L2(0))
	  EXIT SUB
	CASE 66
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N16L2(0)), VARPTR(TILE1X2N16L2(0))
	  EXIT SUB
	CASE 67
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N17L2(0)), VARPTR(TILE1X2N17L2(0))
	  EXIT SUB
	CASE 68
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N18L2(0)), VARPTR(TILE1X2N18L2(0))
	  EXIT SUB
	CASE 69
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N19L2(0)), VARPTR(TILE1X2N19L2(0))
	  EXIT SUB
	CASE 70
	  DQBPUT 1, X, Y, VARSEG(TILE1X2N20L2(0)), VARPTR(TILE1X2N20L2(0))
	  EXIT SUB
	CASE 71
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N1L2(0)), VARPTR(TILE1X3N1L2(0))
	  EXIT SUB
	CASE 72
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N2L2(0)), VARPTR(TILE1X3N2L2(0))
	  EXIT SUB
	CASE 73
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N3L2(0)), VARPTR(TILE1X3N3L2(0))
	  EXIT SUB
	CASE 74
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N4L2(0)), VARPTR(TILE1X3N4L2(0))
	  EXIT SUB
	CASE 75
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N5L2(0)), VARPTR(TILE1X3N5L2(0))
	  EXIT SUB
	CASE 76
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N6L2(0)), VARPTR(TILE1X3N6L2(0))
	  EXIT SUB
	CASE 77
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N7L2(0)), VARPTR(TILE1X3N7L2(0))
	  EXIT SUB
	CASE 78
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N8L2(0)), VARPTR(TILE1X3N8L2(0))
	  EXIT SUB
	CASE 79
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N9L2(0)), VARPTR(TILE1X3N9L2(0))
	  EXIT SUB
	CASE 80
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N10L2(0)), VARPTR(TILE1X3N10L2(0))
	  EXIT SUB
	CASE 81
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N11L2(0)), VARPTR(TILE1X3N11L2(0))
	  EXIT SUB
	CASE 82
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N12L2(0)), VARPTR(TILE1X3N12L2(0))
	  EXIT SUB
	CASE 83
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N13L2(0)), VARPTR(TILE1X3N13L2(0))
	  EXIT SUB
	CASE 84
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N14L2(0)), VARPTR(TILE1X3N14L2(0))
	  EXIT SUB
	CASE 85
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N15L2(0)), VARPTR(TILE1X3N15L2(0))
	  EXIT SUB
	CASE 86
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N16L2(0)), VARPTR(TILE1X3N16L2(0))
	  EXIT SUB
	CASE 87
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N17L2(0)), VARPTR(TILE1X3N17L2(0))
	  EXIT SUB
	CASE 88
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N18L2(0)), VARPTR(TILE1X3N18L2(0))
	  EXIT SUB
	CASE 89
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N19L2(0)), VARPTR(TILE1X3N19L2(0))
	  EXIT SUB
	CASE 90
	  DQBPUT 1, X, Y, VARSEG(TILE1X3N20L2(0)), VARPTR(TILE1X3N20L2(0))
	  EXIT SUB
	CASE 91
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N1L2(0)), VARPTR(TILE1X4N1L2(0))
	  EXIT SUB
	CASE 92
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N2L2(0)), VARPTR(TILE1X4N2L2(0))
	  EXIT SUB
	CASE 93
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N3L2(0)), VARPTR(TILE1X4N3L2(0))
	  EXIT SUB
	CASE 94
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N4L2(0)), VARPTR(TILE1X4N4L2(0))
	  EXIT SUB
	CASE 95
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N5L2(0)), VARPTR(TILE1X4N5L2(0))
	  EXIT SUB
	CASE 96
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N6L2(0)), VARPTR(TILE1X4N6L2(0))
	  EXIT SUB
	CASE 97
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N7L2(0)), VARPTR(TILE1X4N7L2(0))
	  EXIT SUB
	CASE 98
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N8L2(0)), VARPTR(TILE1X4N8L2(0))
	  EXIT SUB
	CASE 99
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N9L2(0)), VARPTR(TILE1X4N9L2(0))
	  EXIT SUB
	CASE 100
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N10L2(0)), VARPTR(TILE1X4N10L2(0))
	  EXIT SUB
	CASE 101
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N11L2(0)), VARPTR(TILE1X4N11L2(0))
	  EXIT SUB
	CASE 102
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N12L2(0)), VARPTR(TILE1X4N12L2(0))
	  EXIT SUB
	CASE 103
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N13L2(0)), VARPTR(TILE1X4N13L2(0))
	  EXIT SUB
	CASE 104
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N14L2(0)), VARPTR(TILE1X4N14L2(0))
	  EXIT SUB
	CASE 105
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N15L2(0)), VARPTR(TILE1X4N15L2(0))
	  EXIT SUB
	CASE 106
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N16L2(0)), VARPTR(TILE1X4N16L2(0))
	  EXIT SUB
	CASE 107
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N17L2(0)), VARPTR(TILE1X4N17L2(0))
	  EXIT SUB
	CASE 108
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N18L2(0)), VARPTR(TILE1X4N18L2(0))
	  EXIT SUB
	CASE 109
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N19L2(0)), VARPTR(TILE1X4N19L2(0))
	  EXIT SUB
	CASE 110
	  DQBPUT 1, X, Y, VARSEG(TILE1X4N20L2(0)), VARPTR(TILE1X4N20L2(0))
	  EXIT SUB
	CASE 111
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N1L2(0)), VARPTR(TILE2X1N1L2(0))
	  EXIT SUB
	CASE 112
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N2L2(0)), VARPTR(TILE2X1N2L2(0))
	  EXIT SUB
	CASE 113
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N3L2(0)), VARPTR(TILE2X1N3L2(0))
	  EXIT SUB
	CASE 114
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N4L2(0)), VARPTR(TILE2X1N4L2(0))
	  EXIT SUB
	CASE 115
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N5L2(0)), VARPTR(TILE2X1N5L2(0))
	  EXIT SUB
	CASE 116
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N6L2(0)), VARPTR(TILE2X1N6L2(0))
	  EXIT SUB
	CASE 117
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N7L2(0)), VARPTR(TILE2X1N7L2(0))
	  EXIT SUB
	CASE 118
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N8L2(0)), VARPTR(TILE2X1N8L2(0))
	  EXIT SUB
	CASE 119
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N9L2(0)), VARPTR(TILE2X1N9L2(0))
	  EXIT SUB
	CASE 120
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N10L2(0)), VARPTR(TILE2X1N10L2(0))
	  EXIT SUB
	CASE 121
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N11L2(0)), VARPTR(TILE2X1N11L2(0))
	  EXIT SUB
	CASE 122
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N12L2(0)), VARPTR(TILE2X1N12L2(0))
	  EXIT SUB
	CASE 123
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N13L2(0)), VARPTR(TILE2X1N13L2(0))
	  EXIT SUB
	CASE 124
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N14L2(0)), VARPTR(TILE2X1N14L2(0))
	  EXIT SUB
	CASE 125
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N15L2(0)), VARPTR(TILE2X1N15L2(0))
	  EXIT SUB
	CASE 126
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N16L2(0)), VARPTR(TILE2X1N16L2(0))
	  EXIT SUB
	CASE 127
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N17L2(0)), VARPTR(TILE2X1N17L2(0))
	  EXIT SUB
	CASE 128
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N18L2(0)), VARPTR(TILE2X1N18L2(0))
	  EXIT SUB
	CASE 129
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N19L2(0)), VARPTR(TILE2X1N19L2(0))
	  EXIT SUB
	CASE 130
	  DQBPUT 1, X, Y, VARSEG(TILE2X1N20L2(0)), VARPTR(TILE2X1N20L2(0))
	  EXIT SUB
	CASE 131
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N1L2(0)), VARPTR(TILE2X2N1L2(0))
	  EXIT SUB
	CASE 132
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N2L2(0)), VARPTR(TILE2X2N2L2(0))
	  EXIT SUB
	CASE 133
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N3L2(0)), VARPTR(TILE2X2N3L2(0))
	  EXIT SUB
	CASE 134
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N4L2(0)), VARPTR(TILE2X2N4L2(0))
	  EXIT SUB
	CASE 135
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N5L2(0)), VARPTR(TILE2X2N5L2(0))
	  EXIT SUB
	CASE 136
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N6L2(0)), VARPTR(TILE2X2N6L2(0))
	  EXIT SUB
	CASE 137
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N7L2(0)), VARPTR(TILE2X2N7L2(0))
	  EXIT SUB
	CASE 138
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N8L2(0)), VARPTR(TILE2X2N8L2(0))
	  EXIT SUB
	CASE 139
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N9L2(0)), VARPTR(TILE2X2N9L2(0))
	  EXIT SUB
	CASE 140
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N10L2(0)), VARPTR(TILE2X2N10L2(0))
	  EXIT SUB
	CASE 141
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N11L2(0)), VARPTR(TILE2X2N11L2(0))
	  EXIT SUB
	CASE 142
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N12L2(0)), VARPTR(TILE2X2N12L2(0))
	  EXIT SUB
	CASE 143
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N13L2(0)), VARPTR(TILE2X2N13L2(0))
	  EXIT SUB
	CASE 144
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N14L2(0)), VARPTR(TILE2X2N14L2(0))
	  EXIT SUB
	CASE 145
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N15L2(0)), VARPTR(TILE2X2N15L2(0))
	  EXIT SUB
	CASE 146
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N16L2(0)), VARPTR(TILE2X2N16L2(0))
	  EXIT SUB
	CASE 147
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N17L2(0)), VARPTR(TILE2X2N17L2(0))
	  EXIT SUB
	CASE 148
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N18L2(0)), VARPTR(TILE2X2N18L2(0))
	  EXIT SUB
	CASE 149
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N19L2(0)), VARPTR(TILE2X2N19L2(0))
	  EXIT SUB
	CASE 150
	  DQBPUT 1, X, Y, VARSEG(TILE2X2N20L2(0)), VARPTR(TILE2X2N20L2(0))
	  EXIT SUB
  END SELECT
END SUB

SUB ULTRAPRINT (TEXT$, X, Y, FCOL, SCOL, XSIZE, YSIZE, STYLE)
	FOR x1 = 1 TO LEN(TEXT$)
		VPRINT VIDEO, (X + x1 * 8), Y, MID$(TEXT$, x1, 1), FCOL, SCOL, XSIZE, YSIZE, STYLE
		FOR x2 = 1 TO 1000
			FOR y2 = 1 TO 1000
			NEXT
		NEXT
	NEXT
END SUB

SUB VPRINT (LAYER, X, Y, TEXT$, FCOL, SCOL, XSIZE, YSIZE, STYLE)
DEF SEG = &HFFA6
XPOS = X
YPOS = Y
FOR LETTER = 1 TO LEN(TEXT$)
	FOR I = YPOS TO YPOS + YSIZE - 1 STEP YSIZE \ 8
		CHAR$ = MID$(TEXT$, LETTER, 1)
		CHAR = ASC(CHAR$)
		Mask = PEEK(&HE + (CHAR * 8) + (I \ (YSIZE \ 8) - Y))
		FOR J = 0 TO 7
			IF Mask AND (2 ^ (7 - J)) THEN
				IF STYLE AND 2 THEN
					DQBpset LAYER, XPOS + (XSIZE \ 8), I, SCOL
					IF XSIZE AND 16 THEN DQBpset LAYER, XPOS + (XSIZE \ 8) + 1, I, SCOL
					IF YSIZE AND 16 THEN DQBpset LAYER, XPOS + (XSIZE \ 8), I + 1, SCOL
					IF XSIZE AND 32 THEN DQBpset LAYER, XPOS + (XSIZE \ 8) + 2, I, SCOL
					IF YSIZE AND 32 THEN DQBpset LAYER, XPOS + (XSIZE \ 8), I + 2, SCOL
				END IF
				DQBpset LAYER, XPOS, I, FCOL
				IF XSIZE AND 16 THEN DQBpset LAYER, XPOS + 1, I, FCOL
				IF YSIZE AND 16 THEN DQBpset LAYER, XPOS, I + 1, FCOL
				IF XSIZE AND 32 THEN DQBpset LAYER, XPOS + 2, I, FCOL
				IF YSIZE AND 32 THEN DQBpset LAYER, XPOS, I + 2, FCOL
			END IF
			IF STYLE AND 1 THEN
				DQBpset LAYER, XPOS, YPOS + YSIZE, SCOL
				IF XSIZE AND 16 THEN DQBpset LAYER, XPOS + 1, YPOS + YSIZE, SCOL
				IF YSIZE AND 16 THEN DQBpset LAYER, XPOS, I + 1 + YSIZE, SCOL
				IF XSIZE AND 32 THEN DQBpset LAYER, XPOS + 2, I + YSIZE, SCOL
				IF YSIZE AND 32 THEN DQBpset LAYER, XPOS, I + 2 + YSIZE, SCOL
			END IF
			XPOS = XPOS + (XSIZE \ 8)
		NEXT J
		XPOS = XPOS - XSIZE
	NEXT I
	XPOS = XPOS + XSIZE
NEXT LETTER
DEF SEG
END SUB

REM $STATIC
DEFSNG A-Z
SUB WAITRETRACE

WAIT (&H3DA), 8
WAIT (&H3DA), 8, 8

END SUB

